program GetUART_v10;
{
}


uses crt,keycodes;

const test=true;     { zawsze domyslny COM           }
      info=true;     { Wywietla dodatkowe informacje}
var port_s       : string;              { Nazwa portu szeregowego }
    baza         : ^word;               { adres portu }
    uart_16Cx50  : boolean;             { Typ UART'a}
    x:byte;
    c:byte;
    E:Tevent;

const RHR=0;                            { Adresy rejestrw UART'a }
      THR=0;
      IER=1;
      ISR=2;
      FCR=2;
      LCR=3;
      MCR=4;
      LSR=5;
      MSR=6;
      SPR=7;
      DLL=0;
      DLM=1;

{------------------------ P R O C E D U R Y -----------------------------}
PROCEDURE UpString(var s:string);   { Zamienia znaki z acucha bdcego }
var i : Integer;                    { parametrem, wynik zwraca w tym     }
begin                               { samym acuchu                     }
  for i := 1 to Length(s) do
    s[i] := UpCase(s[i]);
end;

PROCEDURE WriteHexNible(d:byte);        { Wywielta nible w hex }
begin
 d:=d and $f;                           { Tylko modszy nible  }
 if d<$a then
   write(d)
 else if d=$a then
   write('A')
 else if d=$b then
   write('B')
 else if d=$c then
   write('C')
 else if d=$d then
   write('D')
 else if d=$e then
   write('E')
 else if d=$f then
   write('F')

end;

PROCEDURE WriteHexByte(d:byte);         { Wywielta bajt w hex }
begin
  WriteHexNible(d div 16);
  WriteHexNible(d);
end;

PROCEDURE WriteHexWord(d:word);         { Wywielta slowo w hex }
begin
  WriteHexByte(d div 256);
  WriteHexByte(d);
end;

PROCEDURE PutChar(znak:char);
begin
  delay(1);
  while (port[baza^+LSR] and $40)=0 do ; { czeka az znak zostanie wyslany }
  port[baza^+THR]:=byte(znak);              { wysylac kody ascii }
end;

PROCEDURE PutString(znaki:string);
var x:byte;
begin
  for x:=1 to Length(znaki) do
    begin
      if znaki[x]=#13 then PutChar(#10);
        PutChar(char(znaki[x]));
    end;
end;


PROCEDURE InitGSM;
begin
  Writeln('Init:');
  PutString('AT+CLIP=1'+#13); Delay(500);
  PutString('AT+CMEE=1'+#13); Delay(500);
  PutString('AT+WIND=63'+#13); Delay(500);
  PutString('AT+CNMI=2,1,0,0,0'+#13); Delay(500);
  PutString('AT+CRC=1'+#13); Delay(500);
end;

PROCEDURE ReadSMS;
begin
  Writeln('Read:');
  PutString('AT+CMGL="ALL"'+#13);
end;

PROCEDURE SendSMS;
begin
  Writeln('Send:');
  PutString('AT+CMGS="7916"'+#13); Delay(1000);
  while (port[baza^+LSR] and 1)=0 do ; { jesli przyszedl znak to wyswietl go }
    Write(char(port[baza^+RHR]));
  PutString('dostep.afd');
  PutChar(#$1a);
end;

PROCEDURE SendSMS2;
begin
  Writeln('Send:');
  PutString('AT+CMGS="7916"'+#13); Delay(1000);
  while (port[baza^+LSR] and 1)=0 do ; { jesli przyszedl znak to wyswietl go }
    Write(char(port[baza^+RHR]));
  PutString('smieszne.anv');
  PutChar(#$1a);
end;


PROCEDURE SendSMSa;
begin
  Writeln('Send:');
  PutString('AT+CMGS="7174"'+#13); Delay(1000);
  while (port[baza^+LSR] and 1)=0 do ; { jesli przyszedl znak to wyswietl go }
    Write(char(port[baza^+RHR]));
  PutString('A');
  PutChar(#$1a);
end;

PROCEDURE SendSMSb;
begin
  Writeln('Send:');
  PutString('AT+CMGS="7174"'+#13); Delay(1000);
  while (port[baza^+LSR] and 1)=0 do ; { jesli przyszedl znak to wyswietl go }
    Write(char(port[baza^+RHR]));
  PutString('B');
  PutChar(#$1a);
end;

PROCEDURE SendSMSc;
begin
  Writeln('Send:');
  PutString('AT+CMGS="7174"'+#13); Delay(1000);
  while (port[baza^+LSR] and 1)=0 do ; { jesli przyszedl znak to wyswietl go }
    Write(char(port[baza^+RHR]));
  PutString('C');
  PutChar(#$1a);
end;


PROCEDURE ATH;
begin
  Writeln('ATH:');
  PutString('ATH'+#13);
end;




{----------------------------- P R O G R A M --------------------------------}
label dupa;
begin
  {----------------- Wczytanie nazwy portu ---------------}
  if test=false then
    begin             { Fragment wykonywany podczas normalnej pracy programu }
      if paramcount<>1 then
        begin
          writeln('Error: Za liczba parametrw!!!'); halt;
        end;
      port_s:=paramstr(1);
    end
  else
    begin             { Fragment wykonywany podczas testowania programu }
      Port_s:='com2';
 end;

  if info=true then
    begin            { Fragment wywietlajcy dodatkowe informacje }
      writeln(port_s);
    end;

     {-------------------- Odnalezienie adresu portu szeregowego ------------}
     UpString(Port_s);                  { Zamie znaki na wielkie            }
     if Port_s='AUX' then               { Sprawdzenie nazwy portu szregowego }
         baza:=Ptr($0040,$0000)
     else if Port_s='COM1' then
         baza:=Ptr($0040,$0000)
     else if Port_s='COM2' then
         baza:=Ptr($0040,$0002)
     else if Port_s='COM3' then
         baza:=Ptr($0040,$0004)
     else if Port_s='COM4' then
         baza:=Ptr($0040,$0006)
     else
       begin
         Writeln('Error: Nie znam portu szeregowego ',Port_S,' !!!'); halt;
       end;

     if baza^=0 then                    { Sprawdzenie czy port istnieje w systemie }
       begin
         Writeln('Error: Port ',Port_S,' nieaktywny!!!'); halt;
       end;

  {---------------- Sprawdzenie czy 16c450 ------------------------------}
  uart_16Cx50:=true; { Zakadamy, e uart jest 16Cx50 }
  port[baza^+SPR]:=$aa;
  if port[baza^+SPR]<>$aa then uart_16Cx50:=false; { Brak rejestru 7 wiadczy, e nie }
  port[baza^+SPR]:=$55;
  if port[baza^+SPR]<>$55 then uart_16Cx50:=false;

  if info=true then
    begin            { Fragment wywietlajcy dodatkowe informacje }
      if uart_16Cx50=true then writeln('UART 16C550')
      else  writeln('UART 16C450')
    end;

  {---------------- Inicjalizacja UART'a --------------------------------}
  port[baza^+MCR]:=$00;   { sprzetowa blokada IRQ }
  port[baza^+LCR]:=$80;   { Udostpnienie rejestrw podzielnika }
  port[baza^+DLL]:=$0C; port[baza^+DLM]:=$00;  { predkosc transmisji 9600 }
  port[baza^+IER]:=$00;   { init przerwa }
  port[baza^+FCR]:=$01;   { init fifo }
  port[baza^+LCR]:=$03;   { init format ramki }
  port[baza^+MCR]:=$00;   { init RTS, DTR, sprzetowa blokada IRQ }
  port[baza^+SPR]:=$ff;   { init wolny rejestr }
  if port[baza^+LSR]=0 then;  { Odczyt aby skasowac ewentualne IRQ }
  if port[baza^+MSR]=0 then;  { Odczyt aby skasowac rejestr }

  Writeln('F1-wyswietl rejestry');
  Writeln('F2-init GSM');
  Writeln('F3-read SMS');
  Writeln('F4-send SMS');
  Writeln('F5-send SMS2');
  Writeln('F10-Rozlacz');
  Writeln('CTRL+A/B/C-Send SMS');
  Writeln('ALT+X-Wyjscie');
  Writeln('Odczytuje znaki z portu szeregowego...');
   port[baza^+MCR]:=$03;   { ??? init RTS, DTR, sprzetowa blokada IRQ }
   writeln;
   repeat
     begin
        GetKeyEvent(E);
        if E.What=evKeydown then
        begin
{
   write('KeyCode:$'); WriteHexWord(E.Keycode);
   write(' CharCode:$'); WriteHexByte(byte(E.Charcode));
   write(' ScanCode:$'); WriteHexByte(E.ScanCode);
   writeln;
}
          if E.Keycode=$2D00 then goto dupa {ALT+X}
	  else if E.Keycode=$1E01 then SendSMSa { CTRL+A }
	  else if E.Keycode=$3002 then SendSMSb { CTRL+B }
	  else if E.Keycode=$2E03 then SendSMSc { CTRL+C }
          else if E.ScanCode=$3C then InitGSM { F2 }
          else if E.ScanCode=$3D then ReadSMS { F3 }
          else if E.ScanCode=$3E then SendSMS {F4}
          else if E.ScanCode=$3F then SendSMS2 {F5}
          else if E.ScanCode=$44 then ATH {F10 }
          else if E.ScanCode=$3B then { Jesli F1 to wyswietl rejestry }
	    begin
               Writeln;
	       if (port[baza^+MSR] and $80)<>0 then Write('DCD ');
               if (port[baza^+MSR] and $40)<>0 then Write('RI ');
               if (port[baza^+MSR] and $20)<>0 then Write('DSR ');
               if (port[baza^+MSR] and $10)<>0 then Write('CTS ');
               Writeln;
            end
          else
            port[baza^+THR]:=byte(E.CharCode);  { wysylac kody ascii }
          end;
      if (port[baza^+LSR] and 1)<>0 then       { jesli przyszedl znak to wyswietl go }
         Write(char(port[baza^+RHR]));

      end;
    until false;
dupa:

end.