program InitUART_v10;
{
 Program resetuje UART programowo
 (C) 2002 by ZPR Sawomir Skrzyski

 Wywoanie:
   InitUart NazwaPortu
 gdzie:
   NazwaPortu:         com1, com2, com3, com4, aux

 ZMIANY:
   v1.0 - wersja pierwsza
}

uses crt;
const test=true;     { zawsze domyslny COM           }
      info=true;     { Wywietla dodatkowe informacje}
var port_s       : string;              { Nazwa portu szeregowego }
    ComAdr:word;
    uart_typ     : string;              { Typ UART'a}
    adres        : word;

const RHR=0;                            { Adresy rejestrw UART'a }
      THR=0;
      IER=1;
      ISR=2;
      FCR=2;
      LCR=3;
      MCR=4;
      LSR=5;
      MSR=6;
      SPR=7;
      DLL=0;
      DLM=1;

{------------------------ P R O C E D U R Y -----------------------------}
PROCEDURE UpString(var s:string);   { Zamienia znaki z acucha bdcego }
var i : Integer;                    { parametrem, wynik zwraca w tym     }
begin                               { samym acuchu                     }
  for i := 1 to Length(s) do
    s[i] := UpCase(s[i]);
end;

PROCEDURE WriteHexNible(d:byte);        { Wywielta nible w hex }
begin
 d:=d and $f;                           { Tylko modszy nible  }
 if d<$a then
   write(d)
 else if d=$a then
   write('A')
 else if d=$b then
   write('B')
 else if d=$c then
   write('C')
 else if d=$d then
   write('D')
 else if d=$e then
   write('E')
 else if d=$f then
   write('F')

end;

PROCEDURE WriteHexByte(d:byte);         { Wywielta bajt w hex }
begin
  WriteHexNible(d div 16);
  WriteHexNible(d);
end;

PROCEDURE WriteHexWord(d:word);         { Wywielta sowo w hex }
begin
  WriteHexByte(d div 256);
  WriteHexByte(d);
end;

{----------------------------- P R O G R A M --------------------------------}
begin
  clrscr;

  {----------------- Wczytanie nazwy portu ---------------}
  if test=false then
    begin             { Fragment wykonywany podczas normalnej pracy programu }
      if paramcount<>1 then
        begin
          writeln('Error: Za liczba parametrw!!!'); halt;
        end;
      port_s:=paramstr(1);
    end
  else
    begin             { Fragment wykonywany podczas testowania programu }
      Port_s:='com3';
 end;



     {-------------------- Odnalezienie adresu portu szeregowego ------------}
     UpString(Port_s);                  { Zamie znaki na wielkie            }
     if Port_s='AUX' then               { Sprawdzenie nazwy portu szregowego }
         ComAdr:=Memw[$40:0]
     else if Port_s='COM1' then
         ComAdr:=Memw[$40:0]
     else if Port_s='COM2' then
         ComAdr:=Memw[$40:2]
     else if Port_s='COM3' then
         ComAdr:=Memw[$40:4]
     else if Port_s='COM4' then
         ComAdr:=Memw[$40:6]
     else
       begin
         Writeln('Error: Nie znam portu szeregowego ',Port_S,' !!!'); halt;
       end;

     if ComAdr=0 then                    { Sprawdzenie czy port istnieje w systemie }
       begin
         Writeln('Error: Port ',Port_S,' nieaktywny!!!'); halt;
       end;

  {------------------------ Wywietla adres portu -----------------------}
  Write('Adres portu ',Port_s,' =$');  WriteHexWord(ComAdr); Write(', ');

  {---------------- Sprawdzenie czy 8250 czy 16Cx50 ---------------------}
  uart_typ:='';
  port[ComAdr+SPR]:=$aa;
  if port[ComAdr+SPR]<>$aa then uart_typ:='8250'; { Brak rejestru 7 wiadczy, e nie }
  port[ComAdr+SPR]:=$55;
  if port[ComAdr+SPR]<>$55 then uart_typ:='8250';

  {---------------- Sprawdzenie czy 16C450 czy 16C550 -------------------}
  if uart_typ='' then
    begin
      port[ComAdr+FCR]:=$01;				{Wlacz FIFO}
        if (port[ComAdr+ISR] and $C0)=$C0 then
          uart_typ:='16C550'
        else
          uart_typ:='16C450'
    end;

  if info=true then Writeln(uart_typ); { Fragment wywietlajcy dodatkowe informacje }

  {---------------- Inicjalizacja UART'a --------------------------------}
  port[ComAdr+MCR]:=$00;   { sprzetowa blokada IRQ }
  port[ComAdr+LCR]:=$80;   { Udostpnienie rejestrw podzielnika }
  port[ComAdr+DLL]:=$ff; port[ComAdr+DLM]:=$ff;
  port[ComAdr+IER]:=$00;   { init przerwa }
  port[ComAdr+FCR]:=$00;   { init fifo }
  port[ComAdr+LCR]:=$00;   { init format ramki }
  port[ComAdr+MCR]:=$00;   { init RTS, DTR, sprzetowa blokada IRQ }
  port[ComAdr+SPR]:=$ff;   { init wolny rejestr }
  if port[ComAdr+LSR]=0 then;  { Odczyt aby skasowac ewentualne IRQ }
  if port[ComAdr+MSR]=0 then;  { Odczyt aby skasowac rejestr }

  {---------------- Wywietlenie stanu rejestrw ------------------------}
  write('IER [$00] =$'); WriteHexByte(port[ComAdr+IER]); Writeln;
  write('ISR [$01] =$'); WriteHexByte(port[ComAdr+ISR]); Writeln;
  write('LCR [$00] =$'); WriteHexByte(port[ComAdr+LCR]); Writeln;
  write('MCR [$00] =$'); WriteHexByte(port[ComAdr+MCR]); Writeln;
  write('LSR [$60] =$'); WriteHexByte(port[ComAdr+LSR]); Writeln;
  write('MSR [$00] =$'); WriteHexByte(port[ComAdr+MSR] and $0f); Writeln;
  write('SPR [$ff] =$'); WriteHexByte(port[ComAdr+SPR]); Writeln;


  if test=true then
    begin             { Fragment wykonywany podczas testowania programu }
      Writeln('>>> Wykonano Reset <<<');
      Writeln('Nacinij dowolny klawisz');
      readkey;
    end;

end.