program UartTest_v10;
{
 Wywoanie:
   InitUart NazwaPortu
 gdzie:
   NazwaPortu:         com1, com2, com3, com4, aux

 ZMIANY:
   v1.0 - wersja pierwsza
}

uses crt;
const info=true;     { Wywietla dodatkowe informacje}
var port_s       : string;              { Nazwa portu szeregowego }
    baza         : ^word;               { adres portu }
    uart_typ     : string;              { Typ UART'a}
    x:byte;
    c:byte;

const RHR=0;                            { Adresy rejestrw UART'a }
      THR=0;
      IER=1;
      ISR=2;
      FCR=2;
      LCR=3;
      MCR=4;
      LSR=5;
      MSR=6;
      SPR=7;
      DLL=0;
      DLM=1;

{------------------------ P R O C E D U R Y -----------------------------}
PROCEDURE UpString(var s:string);   { Zamienia znaki z acucha bdcego }
var i : Integer;                    { parametrem, wynik zwraca w tym     }
begin                               { samym acuchu                     }
  for i := 1 to Length(s) do
    s[i] := UpCase(s[i]);
end;

PROCEDURE WriteHexNible(d:byte);        { Wywielta nible w hex }
begin
 d:=d and $f;                           { Tylko modszy nible  }
 if d<$a then
   write(d)
 else if d=$a then
   write('A')
 else if d=$b then
   write('B')
 else if d=$c then
   write('C')
 else if d=$d then
   write('D')
 else if d=$e then
   write('E')
 else if d=$f then
   write('F')

end;

PROCEDURE WriteHexByte(d:byte);         { Wywielta bajt w hex }
begin
  WriteHexNible(d div 16);
  WriteHexNible(d);
end;

PROCEDURE test;
begin
  if info=true then
    begin            { Fragment wywietlajcy dodatkowe informacje }
      write(port_s,' - ');
    end;

     {-------------------- Odnalezienie adresu portu szeregowego ------------}
     UpString(Port_s);                  { Zamie znaki na wielkie            }
     if Port_s='AUX' then               { Sprawdzenie nazwy portu szregowego }
         baza:=Ptr($0040,$0000)
     else if Port_s='COM1' then
         baza:=Ptr($0040,$0000)
     else if Port_s='COM2' then
         baza:=Ptr($0040,$0002)
     else if Port_s='COM3' then
         baza:=Ptr($0040,$0004)
     else if Port_s='COM4' then
         baza:=Ptr($0040,$0006)
     else
       begin
         Writeln('Error: Nie znam portu szeregowego ',Port_S,' !!!'); halt;
       end;

     if baza^=0 then                    { Sprawdzenie czy port istnieje w systemie }
       begin
         Writeln('Error: Port ',Port_S,' nieaktywny!!!'); halt;
       end;

  {---------------- Sprawdzenie czy 8250 czy 16Cx50 ---------------------}
  uart_typ:='';
  port[baza^+SPR]:=$aa;
  Delay(10);
  if port[baza^+SPR]<>$aa then uart_typ:='8250'; { Brak rejestru 7 wiadczy, e nie }
  port[baza^+SPR]:=$55;
  Delay(10);
  if port[baza^+SPR]<>$55 then uart_typ:='8250';

  {---------------- Sprawdzenie czy 16C450 czy 16C550 -------------------}
  if uart_typ='' then
    begin
      port[baza^+FCR]:=$01;				{Wlacz FIFO}
        if (port[baza^+ISR] and $C0)=$C0 then
          uart_typ:='16C550'
        else
          uart_typ:='16C450'
    end;

  if info=true then Writeln(uart_typ); { Fragment wywietlajcy dodatkowe informacje }

  {---------------- Inicjalizacja UART'a --------------------------------}
  port[baza^+MCR]:=$00;   { sprzetowa blokada IRQ }
  port[baza^+LCR]:=$80;   { Udostpnienie rejestrw podzielnika }
  port[baza^+DLL]:=$06; port[baza^+DLM]:=$00;  { predkosc transmisji }
  port[baza^+IER]:=$00;   { init przerwa }
  port[baza^+FCR]:=$00;   { wylacz fifo }
  port[baza^+LCR]:=$03;   { init format ramki }
  port[baza^+MCR]:=$00;   { init RTS, DTR, sprzetowa blokada IRQ }
  port[baza^+SPR]:=$ff;   { init wolny rejestr }
  if port[baza^+LSR]=0 then;  { Odczyt aby skasowac ewentualne IRQ }
  if port[baza^+MSR]=0 then;  { Odczyt aby skasowac rejestr }


   Write('Test RxD/TxD...');
   port[baza^+FCR]:=$00;   { wylacz fifo }
   port[baza^+THR]:=$aa;
   Delay(100);
   if port[baza^+RHR]=$aa then
     begin
       port[baza^+THR]:=$55;
       Delay(100);
       if port[baza^+RHR]=$55 then
         Writeln('       - OK')
       else
         Writeln('       - Fail');
     end
   else
     Writeln('       - Fail');

  Write('Test DTR, DCD, DSR...');
  port[baza^+MCR]:=$01; { aktywne DTR -> CD, DSR }
  Delay(10);
  if (port[baza^+MSR] and $a0)=$a0 then
    begin
     port[baza^+MCR]:=$00; { nieaktywne DTR -> CD, DSR }
     Delay(10);
     if (port[baza^+MSR] and $a0)=$00 then
       Writeln(' - OK')
     else
       begin
         if (port[baza^+MSR] and $a0)=$a0 then
           Writeln(' - Fail DTR')
         else if (port[baza^+MSR] and $20)=$20 then Writeln(' - Fail DSR')
         else if (port[baza^+MSR] and $80)=$80 then Writeln(' - Fail DSR')
       end;
    end
  else
    begin
     if (port[baza^+MSR] and $a0)=$00 then
       Writeln(' - Fail DTR')
     else if (port[baza^+MSR] and $20)=$00 then Writeln(' - Fail DSR')
     else if (port[baza^+MSR] and $80)=$00 then Writeln(' - Fail DSR')
    end;


  Write('Test RTS, DSR, RI...');
  port[baza^+MCR]:=$02; { aktywne RTS-> DSR, RI }
  Delay(10);
  if (port[baza^+MSR] and $50)=$50 then
    begin
     port[baza^+MCR]:=$00; { nieaktywne RTS -> DSR, RI }
     Delay(1);
     if (port[baza^+MSR] and $50)=$00 then
       Writeln('  - OK')
     else
       begin
         if (port[baza^+MSR] and $50)=$50 then
           Writeln('  - Fail RTS1')
         else if (port[baza^+MSR] and $10)=$10 then Writeln('  - Fail CTS')
         else if (port[baza^+MSR] and $40)=$40 then Writeln('  - Fail RI')
       end;
    end
  else
    begin
     if (port[baza^+MSR] and $50)=$00 then
       Writeln('  - Fail RTS')
     else if (port[baza^+MSR] and $10)=$00 then Writeln('  - Fail CTS')
     else if (port[baza^+MSR] and $40)=$00 then Writeln('  - Fail RI')
    end;


  port[baza^+MCR]:=$02;
end;

{----------------------------- P R O G R A M --------------------------------}
var kod_key : char;
label dupa;
begin
  clrscr;
  Writeln('We wtyku testowym nalezy polaczyc wyprowadzenia:');
  Writeln(' 2, 3');
  Writeln(' 4, 5, 22');
  Writeln(' 6, 8, 20');
  Writeln;


  Port_s:='com1';
  test;
  Writeln;
  Port_s:='com2';
  test;
  Writeln;
  Port_s:='com3';
  test;
  Writeln;
  Port_s:='com4';
  test;

  Writeln('>>> Nacisnij dowolny klawisz <<<');
  readkey;


end.