`;
;
;- edycja
;CONST_WAIT_CONNECT
;CONST_DELAY_CONNECT
;CONST_CNT_CONNECT
;
;- edycja komend (patrz rozbudowany plik konfiguracji)
;
;Okreslanie czestotliwosc kwarcu przy uarcie
; wylaczyc IRQ
; ustawic timer na licznik czasu
; wpisac do uarta predkosc np 1200bd
; wpisac znak do uarta
; uruchomic timer
; czekac na bit TR w uarcie
; zatrzymac timer
;
; wartosc z timera porownac z tabela
; w tabeli
; TH TL MLL MLH Q
; xx xx yy yy  1,8432 MHz
; xx xx yy yy  3,6864 MHz
; xx xx yy yy  4,9152 MHz
; xx xx yy yy  7,3728 MHz
; xx xx yy yy 11,592  MHz
; xx xx yy yy 18,432  MHz
;
;W modem 51 zrbic wykrywanie wielkosci ram:
;proba zapisu ram jak dla 32K
;jesli zapis Ok - RAm32k
;zapis zly to proba zapisu z maska bitu A13
;jesli zapis Ok - RAm8k
;zapis zly to blad pamieci.
;
;>>>>>>>>>>>>>>>>>>>>>>>> kompilacja F9 (emu51-64) <<<<<<<<<<<<<<<<<<<<<<<<

HARDWARE                equ     2               ;Hard V1 zamienione SDA i SCL
RTSCTS                  equ     1               ;Jeli 1-RTS/CTS, 0-bez kontroli
UARTIRQ                 equ     0               ;Jeli 1-UART na IRQ
;
;------------------------------------------------
EMU535                  EQU     0               ;ZAWSZE 0 bo ExternalRom
FREQUENCY               equ     1105            ;Czstotliwo kwarcu
RSTIMER                 equ     1               ;Dla include nr timera obsugujcego RS
		        include	'INCL:Global.incl'
		        include	'INCL:8051/S53.incl'
		        include	'INCL:8051/piny_S8252.incl'
                        include 'INCL:8051/baud.incl'
                        include 'INCL:LCD-ASCII_AmigaPL.incl'

LcdBus                  equ     1               ;Typ magistrali LCD
CmdLcdWr		equ	$A000		;Adres portu rozkazw do zapisu
CmdLcdRd		equ	$A002		;Adres portu rozkazw(statusu) do odczytu
DataLcdWr		equ	$A001		;Adres portu danych do zapisu
DataLcdRd		equ	$A003		;Adres portu danych do odczytu
H_LCD 		        equ	16		;Liczba kolumn wywietlacza (typowo 8, 16, 20, 40)
V_LCD 		        equ	1		;Liczba wierszy wywietlacza (typowo 1, 2, 4)
FL_16x1A_LCD		equ	TRUE    	;Typ wywietlacza 16x1
FL_WAIT_LCD		equ     TRUE    	;Czekamy na gotowo sterownika czy nie
HOME_ASCII	        equ	$fa		;Kod powrotu kursora w pooenie spoczynkowe
REPEAT_ASCII	        equ     $fb		;Kod znaku powtrzenia, powtarza znak
CURS_ASCII	        equ     $fc		;Kod ustawienia kursora
ASC_END                 equ     $fd
ASC_KOM                 equ     $ff

;-------------------------
STD_TYP1                equ     'CM'            ;Identyfikator pliku konfiguracyjnego
STD_TYP2                equ     '10'
STD_KOD1                equ     $FF             ;Standardowy kod dostepu
STD_KOD2                equ     $FF
STD_KOD3                equ     $FF
STD_KOD4                equ     $FF
STD_KOD5                equ     $FF
STD_KOD6                equ     $FF
STD_LDZW                equ     3               ;Standardowa liczba dzwonkw

SPEED_0h	        equ     256-40		;  10ms =  10000[s]*(12/12) =
SPEED_0l	        equ     256-8		; 10000 cykli = 39*256+16
CONST_WAIT_CONNECT      equ     90              ;Czas na nawizanie poczenia (w sek)
CONST_DELAY_CONNECT     equ     60              ;Czas pomiedzy prbami poczenia si (w sek)
CONST_CNT_CONNECT       equ     5               ;Liczba prb nawiazania poczenia
CMD_DELAY               equ     100             ;Opznienie po wykonaniu rozkazu (w 1/10 sek)
CONST_OK                equ     3               ;Czas na potwierdzenie rozczenia (w sek)
CONST_RING              equ     10              ;Czas na przyjecie dzwonka (w sek)
CONST_CTS               equ     200             ;Czas na uaktywnienie CTS (w 1/10 sek)
IIC_DELAY_CK            equ     1               ;Opnienie dla linii zegarowej IIC
 IF HARDWARE=1          ;W hardware V1 zamienione linie SDA i SCL
SDA                     equ     P3.4            ;Linia SDA magistarli IIC
SCL                     equ     P3.5            ;Linia SCL magistarli IIC
 ELSE
SDA                     equ     P3.5            ;Linia SDA magistarli IIC
SCL                     equ     P3.4            ;Linia SCL magistarli IIC
 ENDI
LED_ERROR               equ     P1.1            ;Dioda LED czerwona
LED_PROG                equ     P3.3            ;Dioda LED zielona
LED_YELLOW              equ     P1.2            ;Dioda LED ta
SW1                     equ     P1.0            ;Mswitch 1
SW2                     equ     P1.3            ;Mswitch 1
OUT_PROG                equ     P1.5            ;Wyjcie PROG (J4)
OUT_INIT                equ     P1.4            ;Wyjcie INIT (J5)
WDG                     equ     P1.7
SEL_TX                  equ     P1.6            ;Sterowanie multiplekserem
EEPROM_WRITE	        equ	%10100000       ;EEProm
EEPROM_READ	        equ     EEPROM_WRITE+1

RAM                     equ     $0000 OR $2000  ;Adres poczaku RAM
RAME                    equ     $7fff OR $2000  ;Koniec RAM
BUF_RX_MOD              equ     $0000 OR $2000  ; Poczatek bufora odbiorczego Modemu
BUF_MARG                equ     32              ;  krace bufora (sterowanie lini RTS)
BUF_RX_RS2              equ     $0100 OR $2000  ; Poczatek bufora odbiorczego 2
BUF_LCDRS2              equ     $0200 OR $2000  ; Pocztek bufora danych z 2
xram_bodb2              equ     $0300 OR $2000  ; Licznik bajtow odebranych
xram_bodb1              equ     $0301 OR $2000
xram_bodb0              equ     $0302 OR $2000
xram_bnad2              equ     $0303 OR $2000  ; Licznik bajtw nadanych
xram_bnad1              equ     $0304 OR $2000
xram_bnad0              equ     $0305 OR $2000

;...
SIO                     equ     $8000           ;Adres bazowy SIO
RHR                     equ     SIO+0           ; (R)  rejestr odbiorczy SIO
THR                     equ     SIO+0           ; (W)  rejestr nadawczy SIO
IER                     equ     SIO+1           ; (RW) rejestr zezwolenia na IRQ
FCR                     equ     SIO+2           ; (W)  rejestr FIFO
ISR                     equ     SIO+2           ; (R)  rejestr rda przerwania i za FIFO
LCR                     equ     SIO+3           ; (RW) rejestr parametrw transmisji
MCR                     equ     SIO+4           ; (RW) rejestr linii wyjciowych modemu
LSR                     equ     SIO+5           ; (R)  rejestr stanu/bdw
MSR                     equ     SIO+6           ; (R)  rejestr linii wejciowych modemu
SPR                     equ     SIO+7           ; (RW) rejestr/komrka RAM
DLL                     equ     SIO+0           ; (RW) rejestr dzielnika (modszy)
DLM                     equ     SIO+1           ; (RW) rejestr dzielnika (starszy)
DTR                     equ     0               ; linia DTR w rej. MCR
RTS                     equ     1               ; linia RTS w rej. MCR
DCD                     equ     7               ; linia DCD w rej. MSR
RingI                   equ     6               ; linia RI  w rej. MSR
DSR                     equ     5               ; linia DSR w rej. MSR
CTS                     equ     4               ; linia CTS w rej. MSR
dDCD                    equ     3               ; delta DCD w rej. MSR
dRingI                  equ     2               ; delta RI  w rej. MSR
dDSR                    equ     1               ; delta DSR w rej. MSR
dCTS                    equ     0               ; delta CTS w rej. MSR

PIO                     equ     $C000           ;Adres rejestrw I/O

ERR_OK                  equ     0               ;Kody bdw
ERR_INIT_MODEM          equ     3               ; inicjalizacja modemu (nieodpowiedzia na AT)
ERR_STOS                equ     4               ; przekroczono stos
ERR_XRAM                equ     5               ; niewykryto RAM
ERR_SIO                 equ     6               ; niewykryto UARTa
ERR_EEPROM              equ     7               ; niewykryto EEPROM
ERR_INIT_IIC            equ     8               ; uszkodzona magistarala IIC
ERR_CTS                 equ     9               ; za dugo nieaktywny sygna CTS

ST_OK                   equ     0               ;Kody statusw
ST_OVERTIME             equ     1               ; min czas
ST_RING                 equ     2               ; przyszed dzwonek
ST_SW1                  equ     3               ; nacinieto SW 1
ST_SW2                  equ     4               ; nacinieto SW 2

;============================================================================
;     Wewntrzna przestrze adresowa procesora
;----------------------------------
;>>> Adresowanie bezporednie i indeksowe
;----------------------------------
;
;       $00-$07 bank 0 rejestrw
;
wsk_rx_mod_w            equ     $08             ;Wskanik bufora odbiorczego
wsk_rx_mod_r            equ     $09
stdio                   equ     $0a             ;Standardowe IO
NIL                     equ     0               ; wysyanie znakw do pustego zbioru
STDIO_MODEM             equ     1               ; wysyanie znakw do modemu
STDIO_RS2               equ     2               ; wysyanie znakw do RS2
STDIO_LCD               equ     3               ; wysyanie znakw na LCD
cmd_buf                 equ     $0b             ;Bufor na komendy
cmd_bufE                equ     $1b
overtime                equ     $1c             ;Licznik odliczajacy czas
licznik100              equ     $1d             ;Dzielnik wstpny
cnt_connect             equ     $1e             ;Licznik prb pocze
cnt_crc                 equ     $1f             ;Licznik sumy kontrolnej
cfg_kod1                equ     $20             ;Kod dostepu
cfg_kod2                equ     $21
cfg_kod3                equ     $22
cfg_kod4                equ     $23
cfg_kod5                equ     $24
cfg_kod6                equ     $25
cfg_ldzw                equ     $26             ;Liczba dzwonkw
dana_ee                 equ     $27             ;Dana tymczasowa podczas zapisu EEPROM
ostatni_err             equ     $28             ;Kod ostatniego bdu
testL                   equ     $29             ;Testowanie przyczyny restartu
testH                   equ     $2a             ; j/w
bnad0                   equ     $2b             ;Licznik bajtw wysanych
bnad1                   equ     $2c
bnad2                   equ     $2d
pio_out                 equ     $2e             ;Kopia portu PIO
;--------- adresowanie bitowe -------------
FL_WAIT_DATA_LCD        equ     $7b ; $2f.3     ;Flaga oczekiwania na ramk danych
FL_FLASH_OFF            equ     $7c ; $2f.4     ;Flaga blokady flasha leda
FL_STDEEPROM            equ     $7d ; $2f.5     ;Flaga standardowej konfiguracji
FL_TXEMPTY              equ     $7e ; $2f.6     ;Flaga zajtoci nadajnika
FL_IIC_BUSY             equ     $7f ; $2f.7     ;Flaga zajtoci IIC
;
bodb2                   equ     $30             ;Licznik bajtw odebranych
bodb1                   equ     $31
bodb0                   equ     $32
poz_wys                 equ     $33             ;Wskanik znaku na LCD
;...
wsk_fifo_wr             equ     $40             ;Bufor FIFO RS2
wsk_fifo_rd             equ     $41
status_fifo             equ     $42
ERROR_OK                equ     0
ERROR_FIFO              equ     1
buf_fifo_str            equ     $44
buf_fifo_end            equ     $7f
;...
;...
wierzch_stosu           equ     $80             ;wierzch stosu
dno_stosu               equ     $FF             ;dno stosu i komrka kontrolna stosu
KONT_STOS               equ     'T'             ;bajt kontroli stosu

;============================================================================
		org	$0000
		ljmp	start

;----------------------------------------------------------------------------
		org	$03                     ;Int0
                ljmp    irq_uart

;----------------------------------------------------------------------------
		org	$0b                     ;Timer0
		ljmp	irq_timer   		;Przerwanie z timera 0

;----------------------------------------------------------------------------
		org	$23                     ;IntRS
		ljmp	irq_rs       		;Przerwanie z RS'a

;============================================================================
;Obsuga IIC
                include 'INCL:8051/IIC.incl'
                include 'INCL:8051/LCD_HT44780.incl'
                include 'INCL:LCD-Data_PL.incl'

;============================================================================
;=                  RESET - inicjalizacja procesora, itp                    =
;============================================================================
restart         clr     EA                      ;Restart - wycz IRQ
                sjmp    *                       ; i wieczna petla co spowoduje, e Watchdog ruszy ten baagan

start:          setb    FL_FLASH_OFF            ;Zablokuj flash LEDa
                clr     LED_YELLOW              ; wcz go na stae
                mov	SP,#wierzch_stosu   	;Ustawienie stosu
                mov     R0,#dno_stosu           ;Wypenij stos bajtem
start_l1:       mov     @R0,#KONT_STOS          ; kontrolnym przepenienia stosu
                dec     R0                      ; co umoliwi okrelenie
                mov     a,R0                    ; max zuycia stosu
                cjne    a,#wierzch_stosu,start_l1
                mov     a,#$ff                  ;Stan pocztkowy portu PIO
                lcall   reset_pio
                mov     stdio,#NIL
                lcall   test_xram
                lcall   test_sio
                lcall   init_16C550
                lcall   init_rs
                lcall   init_timer
                lcall   iic_init
                lcall   test_restartu
                cpl     WDG
                lcall   init_lcd
                setb    EA
        ;---------------------------------------
                mov     stdio,#STDIO_LCD        ;Komunikat LCD
                mov     dptr,#msg_sys_init_ok
                lcall   print_text
                lcall   read_konfig
                jb      SW1,start_l2            ;Jesli zwarte SW1 i SW2 to init EEPROMu
                jb      SW2,start_l2
                lcall   std_konfig
start_l2:       lcall   test_cfg
                mov     stdio,#STDIO_MODEM
   ;            lcall   break                   ;??? pokombinowa czy da si to zrobi sprawdzic czy bedzie OK
                lcall   init_modem              ;inicjalizacja i test modemu
                jnc     restart
                clr     FL_FLASH_OFF            ;Odblokuj flash LEDa
                sjmp    odbior

msg_sys_init_ok:BYTE    CLS_ASCII
                STRING  'System Init OK'
                BYTE    NIL

;============================================================================
;Oczekuje na dzwonek po czym zgasza si.
; po nawizaniu poczenia czeka na kod dostpu
;
odbior:         mov     stdio,#STDIO_LCD
                lcall   curs_on_lcd
                mov     dptr,#msg_ready
                lcall   print_text
                mov     R7,cfg_ldzw             ;Liczba dzwonkw do R7
odbior1:        mov     stdio,#STDIO_MODEM
                lcall   wait_ring               ;Czeka na dzwonek
                jc      odbior2                 ; - jest dzwonek, skacz
                lcall   init_modem              ; - nie byo dzwonka, inicjalizuj modem
                sjmp    odbior                  ;   i czekaj na dzwonek
odbior2:        mov     stdio,#STDIO_LCD
                mov     dptr,#msg_ring
                lcall   print_text
                lcall   set_pio
                djnz    R7,odbior1              ;jeli nieostatni dzwonek to skacz
                mov     stdio,#STDIO_LCD
                mov     dptr,#msg_mod_busy
                lcall   print_text
                mov     stdio,#STDIO_MODEM
                lcall   answer                  ;Zgasza si
                lcall   wait_connect            ;Czeka na poczenie
                jnc     odbior_init
                mov     stdio,#STDIO_LCD
                mov     dptr,#msg_mod_connect
                lcall   print_text
                mov     stdio,#STDIO_MODEM
                lcall   print_connect           ;Poczy si
                lcall   res_bnadodb             ; zeruj liczbe bajtow nadanych i odberanych
                lcall   inc_odwiedziny
                clr     LED_ERROR
                lcall   read_konfig
                lcall   test_cfg                  ;Testuj CFG
                jb      FL_STDEEPROM,odbior_kodok ;Jeli STD CFG to nie czekaj na kod dostpu
                lcall   cmp_kod                   ;Czeka na kod
                jnc     odbior_init
odbior_kodok:   lcall   wait_command            ;Interpretuje komendy
odbior_init:    setb    LED_ERROR               ;Inicjalizacja trybu odbioru
                mov     stdio,#STDIO_MODEM
                lcall   break
                mov     a,#CMD_DELAY
                lcall   wait_10ms
                ljmp    odbior

msg_ready:      BYTE    CLS_ASCII
                STRING  'Ready...'
                BYTE    NIL

msg_ring:       BYTE    CLS_ASCII
                STRING  'Ring...'
                BYTE    NIL

msg_mod_busy:   BYTE    CLS_ASCII
                STRING  'Modem BUSY...'
                BYTE    NIL

msg_mod_connect:BYTE    CLS_ASCII
                STRING  'CONNECT...'
                BYTE    NIL

msg_mod_dial:   BYTE    CLS_ASCII
                STRING  'Dial '
                BYTE    NIL

msg_mod_delay:  BYTE    CLS_ASCII
                STRING  'Delay '
                BYTE    NIL

;----------------------------------------------------------------------------
;Prbuje wybrac nr i nawiaza poczenie
; nr znajduje sie w "cmd_buf" (w kodach ASCII) zakoczony kodem #0
; jeli poczy sie nieczeka na kod dostpu
;
;WY: C - status:        C=1-OK, C=0 niepoczono si
;
nadawanie:      mov     cnt_connect,#CONST_CNT_CONNECT  ;Liczba prb poczenia
nadawanie1:     mov     stdio,#STDIO_LCD
                mov     dptr,#msg_mod_dial
                lcall   print_text
                mov     a,cnt_connect
                lcall   print_hex
                mov     stdio,#STDIO_MODEM
                lcall   dial_tone               ;Wybiera nr
                lcall   curs_off_lcd
                mov     R0,#cmd_buf             ;Pocztek bufora
nadawanie3:     mov     a,@R0                   ;Odczytaj znak z bufora
                cjne    a,#NIL,nadawanie2       ; jeli nie koniec nr to skacz
                sjmp    nadawanie4              ; koniec nr wiec wysli CR+LF
nadawanie2:     lcall   print_char              ;Wyslij nr
                inc     R0                      ; wskanik na next znak
                mov     a,R0                    ; czy koniec bufora ?
                cjne    a,#cmd_bufE,nadawanie3
nadawanie4:     lcall   print_crlf              ; zatwierd nr kodem CR+LF

                mov     overtime,#CONST_WAIT_CONNECT    ;Czeka na poczenie lub dzwonek
nadawanie41:    mov     dptr,#MSR                       ;Odczyt rejestru MSR
                movx    a,@dptr
                jb      ACC+DCD,nadawanie42             ;Jest DCD to doszo do poczenia
                jb      ACC+RingI,nadawanie_fail        ;Jest dzwonek to wyjd z procedury
                lcall   flash_led
                mov     stdio,#STDIO_LCD                ;Wywietlenie upywajcego czasu
                mov     a,#8
                lcall   print_overtime
                mov     a,overtime                      ;Czy min czas?
                cjne    a,#0,nadawanie41                ;- nie to czekaj dalej

nadawanie_init: mov     dptr,#msg_mod_delay
                lcall   print_text
                lcall   curs_off_lcd
                setb    LED_ERROR               ;Kolejna prba
                mov     stdio,#STDIO_MODEM
                lcall   break
                mov     stdio,#STDIO_LCD        ;przerwa przed kolejna prb
                mov     overtime,#CONST_DELAY_CONNECT
nadawanie_init1:mov     stdio,#STDIO_LCD        ;Wywietlenie upywajcego czasu
                mov     a,#6
                lcall   print_overtime
                mov     dptr,#MSR               ;Czy jest dzwonek
                movx    a,@dptr
                jb      ACC+RingI,nadawanie_fail;Jest dzwonek to wyjd z procedury
                lcall   flash_led
                mov     a,overtime              ;Czy min czas?
                cjne    a,#0,nadawanie_init1    ;-nie wic czekaj dalej
                djnz    cnt_connect,nadawanie1  ;- tak wic kolejna prba ?
nadawanie_fail: clr     C                       ;Wyjscie ze znacznikiem FAIL
                ret

nadawanie42:    mov     stdio,#STDIO_LCD
                mov     dptr,#msg_mod_connect
                lcall   print_text
                lcall   curs_on_lcd
                mov     stdio,#STDIO_MODEM
                lcall   print_connect           ;Poczy si
                lcall   res_bnadodb             ; zeruj liczbe bajtow nadanych i odberanych
                clr     LED_ERROR
                mov     dptr,#msg_kod_ok        ;Kod OK
                lcall   print_text
                lcall   wait_command            ;Interpretuje komendy
                setb    C                       ;Wyjscie ze znacznikiem OK
                ret                             ;Wyjcie

;-----------------------------------------------
;Wywietla czas pozostay do koca (zmienn "overtime")
;WE: Acc - miejsce ustawienia kursora
;
print_overtime: push    ACC
                mov     a,licznik100            ;Wywieylanie tylko co xx ms
                cjne    a,#1,prt_over1
                pop     ACC
                lcall   curs_set_lcd
                mov     a,overtime              ;Czas
                lcall   hex2dec                 ;konwersja na DEC
                push    ACC                     ;zapamitaj jednostki i dziesitki
                mov     a,B                     ;wywietl setki
                lcall   print_nible
                pop     ACC
                lcall   print_hex
                ret

prt_over1:      pop     ACC
                ret

;----------------------------------------------------------------------------
;Ustawia bity portu wyjciowego
;WE: ACC - bity do ustawienia
;WY: ACC - stan portu po operacji
;
set_pio:        push    DPH
                push    DPL
                orl     a,pio_out               ;Ustaw wybrane bity portu
                mov     dptr,#PIO               ;zapisz do portu
                movx    @dptr,a
                mov     pio_out,a               ;zapamitaj stan
                pop     DPL
                pop     DPH
                ret

;-----------------------------------------------
;Kasuje bity portu wyjciowego
;Aby wyzerowa port (ustawi na nim warto $00) naley wykona operacj:  mov  a,#$ff
;                                                                          call reset_pio
;WE: ACC - bity do skasowania
;WY: ACC - stan portu po operacji
;
reset_pio:      push    DPH
                push    DPL
                xrl     a,#$ff                  ;Negacja bitw
                anl     a,pio_out               ;Kasuj wybrane bity portu
                mov     dptr,#PIO               ;zapisz do portu
                movx    @dptr,a
                mov     pio_out,a               ;zapamitaj stan
                pop     DPL
                pop     DPH
                ret

;-----------------------------------------------
;Zapisuje port wyjciowy
;WE: ACC - liczba do zapisania
;WY: ACC - stan portu po operacji
;
write_pio:      push    DPH
                push    DPL
                mov     dptr,#PIO               ;zapisz do portu
                movx    @dptr,a
                mov     pio_out,a               ;zapamitaj stan
                pop     DPL
                pop     DPH
                ret

;-----------------------------------------------
;Odczytuje stan portu wejciowego
;WY: Acc - stan portu
;
read_pio:       push    DPH
                push    DPL
                mov     dptr,#PIO               ;Odczytaj stan portu
                movx    a,@dptr
                pop     DPL
                pop     DPH
                ret

;----------------------------------------------------------------------------
;Incrementuje licznik odwiedzin w EEprom
;
inc_odwiedziny: lcall   read_odwiedziny
                mov     a,B
                add     a,#1
                da      a
                mov     B,a
                mov     a,R7
                addc    a,#0
                da      a
                mov     R7,a
write_odwiedziny:                               ;Zapisuje licznik odwiedzin w eeprom
                mov     dptr,#ee_odwiedzinyL
                mov     a,B
                lcall   write_eeprom
                mov     a,R7
                lcall   write_eeprom
                ret

;----------------------------------------------------------------------------
;Odczytuje licznk odwiedzin z eprom
;WE: --
;WY: B  - modszy bajt
;    R7 - starszy bajt
;Zmienia: Acc, B, R7, dptr
;
read_odwiedziny:mov     dptr,#ee_odwiedzinyL
                lcall   read_eeprom
                mov     B,a
                lcall   read_eeprom
                mov     R7,a
                ret

;============================================================================
;Testowanie przyczyny restartu
; jeli w komrkach kontrolnych bajty wzorcowe to nastapi reset po wczeniu zasilania
;
STD_TESTL       equ     'C'
STD_TESTH       equ     'M'
;
test_restartu:  mov     a,testL                         ;Testuj komrki kontrolne
                cjne    a,#STD_TESTL,restart_power
                mov     a,testH
                cjne    a,#STD_TESTH,restart_power
                ret                                     ;restart - jakis bd
restart_power:  mov     testL,#STD_TESTL                ;restart - power
                mov     testH,#STD_TESTH                ; zapisz komrki testowe
                mov     ostatni_err,#ERR_OK             ; i ustaw znacznik "bez bdu"
                lcall   clr_bnadodb                     ;Zeruje bufory
                ret

;----------------------------------------------------------------------------
;Czeka na poprawny kod, jesli poczenie przerwano wychodzi z C=0
; jesli kod OK C=0
;WY: C - status (C=1-kod OK, C=0-przerwano)
;
cmp_kod:
cmp_kod00:      mov     cnt_connect,#7          ;Licznik prb wprowadenia kodu
cmp_kod0:       lcall   wait_kod
                jnc     kod_fail

                mov     a,cmd_buf               ;Sprawd czy kod awaryjny
                cjne    a,#'C',cmp_kod1
                mov     a,cmd_buf+1
                cjne    a,#'m',cmp_kod1
                mov     a,cmd_buf+2
                cjne    a,#'t',cmp_kod1
                mov     a,cmd_buf+3
                cjne    a,#'M',cmp_kod1
                mov     a,cmd_buf+4
                cjne    a,#'o',cmp_kod1
                mov     a,cmd_buf+5
                cjne    a,#'d',cmp_kod1
                sjmp    cmp_kod2

cmp_kod1:       mov     a,cmd_buf               ;Porwnaj zgodno kodu
                cjne    a,cfg_kod1,cmp_kod3
                mov     a,cmd_buf+1
                cjne    a,cfg_kod2,cmp_kod3
                mov     a,cmd_buf+2
                cjne    a,cfg_kod3,cmp_kod3
                mov     a,cmd_buf+3
                cjne    a,cfg_kod4,cmp_kod3
                mov     a,cmd_buf+4
                cjne    a,cfg_kod5,cmp_kod3
                mov     a,cmd_buf+5
                cjne    a,cfg_kod6,cmp_kod3

cmp_kod2:       mov     dptr,#msg_kod_ok        ;Kod OK
                lcall   print_text
                setb    C
                ret

cmp_kod3:       mov     dptr,#msg_kod_fail1     ;Porwnanie ze, daj komunikat
                lcall   print_text
                mov     a,cnt_connect
                dec     a
                lcall   print_nible
                mov     dptr,#msg_kod_fail2
                lcall   print_text
                djnz    cnt_connect,cmp_kod0    ;Zmniejsz licznik prb
                mov     dptr,#msg_kod_fail3
                lcall   print_text
kod_fail:       clr     C
                ret

msg_kod_ok:     STRING  'Kod poprawny, czekam na rozkazy'
                BYTE    CR,LF,NULL

msg_kod_fail1:  BYTE    CR,LF
                STRING  'Zly kod, pozostalo '
                BYTE    NULL
msg_kod_fail2:  STRING  ' prob.'
                BYTE    NULL
msg_kod_fail3:  BYTE    CR,LF
                STRING  'Wyczerpales limit prob, rozlaczam polaczenie...'
                BYTE    CR,LF,NULL

;----------------------------------------------------------------------------
;Czeka na wprowadzenie szeciu znakw kodu
;WY: C - status (C=1-wprowadzono, C=0-przerwano)
;
wait_kod:       lcall   clr_buf_modem           ;Czy bufor
wait_kod0:      mov     dptr,#msg_kod
                lcall   print_text

                mov     R0,#cmd_buf             ;Pocztek bufora
wait_kod1:      mov     dptr,#MSR               ;Jesli modem straci nona
                movx    a,@dptr                 ; to wyjd z procedury (skok do "run_break")
                jnb     ACC+DCD,wait_kod_brk
                lcall   flash_led               ;Migaj ledem
                lcall   get_char                ;Czekaj na znak z modemu
                jnc     wait_kod1               ; nie ma znaku wi badaj CD
                mov     @R0,a                   ;Zapisz znak do bufora
                inc     R0                      ; wskaxnik na next znak
                mov     a,#'*'                  ; ECHO
                lcall   print_char
                mov     a,R0                    ; czy wszystkie znaki kodu?
                cjne    a,#cmd_buf+6,wait_kod1
                lcall   print_crlf              ;Wyslij CR+LF
                setb    C                       ;Znacznik OK
                ret

wait_kod_brk:   clr     C                       ;Znacznik FAIL
                ret

msg_kod:        BYTE    CR,LF
                STRING  'Wprowadz kod: '
                BYTE    NULL


;----------------------------------------------------------------------------
;Czeka na wprowadzenie jednego znaku
;WY: C   - status (C=1-wprowadzono, C=0-przerwano)
;    Acc - wprowadzony znak
;
wait_char:      lcall   clr_buf_modem           ;Czy bufor
wait_char1:     mov     dptr,#MSR               ;Jesli modem straci nona
                movx    a,@dptr                 ; to wyjd z procedury (skok do "run_break")
                jnb     ACC+DCD,wait_char_brk
                lcall   flash_led               ;Migaj ledem
                lcall   get_char                ;Czekaj na znak z modemu
                jnc     wait_char1              ; nie ma znaku wi badaj CD
                mov     @R0,a                   ;Zapisz znak do bufora
                inc     R0                      ; wskaxnik na next znak
                lcall   print_char              ; ECHO
                setb    C                       ;Znacznik OK
                ret

wait_char_brk:  clr     C                       ;Znacznik FAIL
                ret

;----------------------------------------------------------------------------
;Czeka na wprowadzenie nr zakoczonego enterem
;WY: C - status (C=1-wprowadzono, C=0-przerwano)
;
wait_callback:  lcall   clr_buf_modem           ;Czy bufor
                mov     dptr,#msg_callback
                lcall   print_text
wait_callback0: mov     R0,#cmd_buf             ;Pocztek bufora
wait_callback1: mov     dptr,#MSR               ;Jesli modem straci nona
                movx    a,@dptr                 ; to wyjd z procedury (skok do "run_break")
                jnb     ACC+DCD,wait_callback_brk
                lcall   flash_led               ;Migaj ledem
                lcall   get_char                ;Czekaj na znak z modemu
                jnc     wait_callback1          ; nie ma znaku wi badaj CD
                cjne    a,#CR,wait_callback2    ; jeli ENTER
                sjmp    wait_callback3          ;  to wyjd ze znadcznikiem OK
wait_callback2: cjne    a,#ESC,wait_callback21  ; jeli ESC
                sjmp    wait_callback_brk       ;  to wyjd ze znacznikiem FAIL
wait_callback21:mov     @R0,a                   ;Zapisz znak do bufora
                inc     R0                      ; wskaxnik na next znak
                lcall   print_char              ; ECHO
                mov     a,R0                    ; czy peen bufor ?
                cjne    a,#cmd_bufE,wait_callback1
wait_callback3: mov     a,#NIL                  ;Bufor peny
                mov     @R0,a                   ; zapisz znakkoca
                lcall   print_crlf              ;Wyslij CR+LF
                setb    C                       ;Znacznik OK
                ret

wait_callback_brk:
                clr     C                       ;Znacznik FAIL
                ret

msg_callback:   STRING  'Wprowadz nr: '
                BYTE    NULL

;----------------------------------------------------------------------------
;Czeka na komende i wykonuje ja,
; jesli komendy nie ma wysya komunikat bdu
; Strata nosnej modemu lub rozkaz BREAK powoduje wyjcie z procedury
;
wait_command:   lcall   test_cfg                ;Testuj CFG
                mov     a,#'>'                  ;Drukuj znak zachety
                lcall   print_char
                lcall   clr_buf_modem           ;Czy bufor
wait_command1:  mov     R0,#cmd_buf             ;Poczatek bufora komendy
wait_cmd0:      mov     dptr,#MSR               ;Jesli modem straci nona
                movx    a,@dptr                 ; to wyjd z procedury
                jnb     ACC+DCD,run_break
                lcall   flash_led               ;Migaj ledem
                lcall   get_char                ;Czekaj na znak z modemu
                jnc     wait_cmd0               ; nie ma znaku wi badaj CD
                cjne    a,#10,wait_cmd1         ;Jeli nie LF to skok
                sjmp    run_cmd                 ; jest LF wiec wykonaj komend
wait_cmd1:      cjne    a,#13,wait_cmd2         ;Jeli nie CR to skok
                sjmp    run_cmd                 ; jest LF wiec wykonaj komend
wait_cmd2:      lcall   Upper_char              ;zamien litery na wielkie
                lcall   print_char              ; ECHO
                mov     @R0,a                   ;zapisz znak do bufora
                inc     R0                      ; next znak
                mov     a,R0                    ;Czy koniec bufora ?
                cjne    a,#cmd_bufE+1,wait_cmd0 ; - nie wic zapisuj dalej
                sjmp    wait_command1           ; - tak wic wszystko od nowa
run_cmd:        mov     a,#0                    ;Byo CR lub LF wic wstaw znacznik koca tekstu
                mov     @R0,a
                lcall   print_crlf              ;Wyslij kod CR LF
                mov     a,R0                    ; zapamietaj adres ostatniego znaku w buforze
                mov     R7,a
                inc     R7                      ; korekta

                ;----- analiza komendy BREAK -----
run_cmd_break:  mov     dptr,#cmd_break         ;Adres tekstu komendy
                lcall   cmp_cmd                 ; wykonaj porwnanie
                jnc     run_cmd_about           ; - jeli ze to skok
run_break:      lcall   print_ok                ; to porwnanie OK - wykonaj rozkaz
                lcall   break
                ret                             ; po wykonaniu wyjd z procedury

                ;----- analiza komendy ABOUT -----
run_cmd_about:  mov     dptr,#cmd_about
                lcall   cmp_cmd
                jnc     run_cmd_prgon
                lcall   print_about             ;Wykonanie komendy
                ljmp    wait_command            ; po wykonaniu czekaj na next komend

                ;----- analiza komendy PROG ON -----
run_cmd_prgon:  mov     dptr,#cmd_prgon
                lcall   cmp_cmd
                jnc     run_cmd_prgoff
                clr     OUT_PROG                ;Wykonanie komendy
                lcall   print_ok
                ljmp    wait_command            ; po wykonaniu czekaj na next komend

                ;----- analiza komendy PROG OFF -----
run_cmd_prgoff: mov     dptr,#cmd_prgoff
                lcall   cmp_cmd
                jnc     run_cmd_inion
                setb    OUT_PROG                ;Wykonanie komendy
                lcall   print_ok
                ljmp    wait_command            ; po wykonaniu czekaj na next komend

                ;----- analiza komendy INIT ON -----
run_cmd_inion:  mov     dptr,#cmd_inion
                lcall   cmp_cmd
                jnc     run_cmd_inioff
                clr     OUT_INIT                ;Wykonanie komendy
                lcall   print_ok
                ljmp    wait_command            ; po wykonaniu czekaj na next komend

                ;----- analiza komendy INIT OFF -----
run_cmd_inioff: mov     dptr,#cmd_inioff
                lcall   cmp_cmd
                jnc     run_cmd_ledon
                setb    OUT_INIT                ;Wykonanie komendy
                lcall   print_ok
                ljmp    wait_command            ; po wykonaniu czekaj na next komend

                ;----- analiza komendy LED ON -----
run_cmd_ledon:  mov     dptr,#cmd_ledon
                lcall   cmp_cmd
                jnc     run_cmd_ledoff
                clr     LED_PROG                ;Wykonanie komendy
                lcall   print_ok
                ljmp    wait_command            ; po wykonaniu czekaj na next komend

                ;----- analiza komendy LED OFF -----
run_cmd_ledoff: mov     dptr,#cmd_ledoff
                lcall   cmp_cmd
                jnc     run_cmd_input
                setb    LED_PROG                ;Wykonanie komendy
                lcall   print_ok
                ljmp    wait_command            ; po wykonaniu czekaj na next komend

                ;----- analiza komendy INPUT -----
run_cmd_input:  mov     dptr,#cmd_input
                lcall   cmp_cmd
                jnc     run_cmd_oddzw
                lcall   print_input             ;Wykonanie komendy
                lcall   print_ok
                ljmp    wait_command            ; po wykonaniu czekaj na next komend

                ;----- analiza komendy ODDZWON -----
run_cmd_oddzw:  mov     dptr,#cmd_oddzw
                lcall   cmp_cmd
                jnc     run_cmd_scan
                lcall   wait_callback           ;Czeka na wprowadzenie nr do oddzwonienia
                jnc     run_cmd_scan            ; jeli nr niewprowadzono to skacze
run_cmd_oddzw1: lcall   print_oddzwaniam
                lcall   break                   ; przerwywa poczenie
                lcall   nadawanie               ; czy si z komputerem
                lcall   read_callback           ; przywraca nr callback z eeprom
                ret                             ; po wykonaniu wyjd z procedury

                ;----- analiza komendy SCANIIC -----
run_cmd_scan:   mov     dptr,#cmd_scan
                lcall   cmp_cmd
                jnc     run_cmd_nkod
                lcall   scan_iic                ;Wykonanie komendy
                lcall   print_crlf
                lcall   print_ok
                ljmp    wait_command            ; po wykonaniu czekaj na next komend

                ;----- analiza komendy KOD -----
run_cmd_nkod:   mov     dptr,#cmd_nkod
                lcall   cmp_cmd
                jnc     run_cmd_help1
                lcall   nowy_kod                ;Wykonanie komendy
                ljmp    wait_command            ; po wykonaniu czekaj na next komend

                ;----- analiza komendy HELP1 -----
run_cmd_help1:  mov     dptr,#cmd_help1
                lcall   cmp_cmd
                jnc     run_cmd_help2
                lcall   print_help              ;Wykonanie komendy
                ljmp    wait_command            ; po wykonaniu czekaj na next komend

                ;----- analiza komendy HELP2 -----
run_cmd_help2:  mov     dptr,#cmd_help2
                lcall   cmp_cmd
                jnc     run_cmd_ldzw
                lcall   print_help              ;Wykonanie komendy
                ljmp    wait_command            ; po wykonaniu czekaj na next komend

                ;----- analiza komendy LDZW -----
run_cmd_ldzw:   mov     dptr,#cmd_ldzw
                lcall   cmp_cmd
                jnc     run_cmd_info
                lcall   prog_ldzw               ;Wykonanie komendy
                ljmp    wait_command            ; po wykonaniu czekaj na next komend

                ;----- analiza komendy INFO -----
run_cmd_info:   mov     dptr,#cmd_info
                lcall   cmp_cmd
                jnc     run_cmd_pioo
                lcall   print_info               ;Wykonanie komendy
                ljmp    wait_command            ; po wykonaniu czekaj na next komend

                ;----- analiza komendy PIOOUT -----
run_cmd_pioo:   mov     dptr,#cmd_pioo
                lcall   cmp_cmd
                jnc     run_syntax
                lcall   set_pioo
                ljmp    wait_command            ; po wykonaniu czekaj na next komend

run_syntax:     lcall   print_syntax            ;Nieznana komenda
                ljmp    wait_command

;-----------------------------------
help_start:
cmd_break:      STRING  'Break'
                BYTE    NULL
                STRING        '     - Przerywa polaczenie'
                BYTE    ASC_KOM

cmd_about:      STRING  'About'
                BYTE    NULL
                STRING        '     - Info o urzadzeniu i autorze'
                BYTE    ASC_KOM

cmd_prgon:      STRING  'ProgOn'
                BYTE    NULL
                STRING         '    - Wlacz led D5'
                BYTE    ASC_KOM

cmd_prgoff:     STRING  'ProgOff'
                BYTE    NULL
                STRING          '   - Wylacza led D5'
                BYTE    ASC_KOM

cmd_inion:      STRING  'InitOn'
                BYTE    NULL
                STRING         '    - Wlacza led D4'
                BYTE    ASC_KOM

cmd_inioff:     STRING  'InitOff'
                BYTE    NULL
                STRING          '   - Wylacza led D4'
                BYTE    ASC_KOM

cmd_ledon:      STRING  'LedOn'
                BYTE    NULL
                STRING        '     - Wlacza led D3'
                BYTE    ASC_KOM

cmd_ledoff:     STRING  'LedOff'
                BYTE    NULL
                STRING         '    - Wylacza led D3'
                BYTE    ASC_KOM

cmd_input:      STRING  'Input'
                BYTE    NULL
                STRING        '     - Wyswietla stan portow wejscionych i led'
                BYTE    ASC_KOM

cmd_oddzw:      STRING  'CallBack'
                BYTE    NULL
                STRING           '  - Uruchamia funkcje oddzwon'
                BYTE    ASC_KOM

cmd_scan:       STRING  'ScanIic'
                BYTE    NULL
                STRING          '   - Wyswietla adresy wszystkich urzadzen IIC'
                BYTE    ASC_KOM

cmd_nkod:       STRING  'Kod'
                BYTE    NULL
                STRING      '       - Zmienia kod dostepu'
                BYTE    ASC_KOM

cmd_help1:      STRING  'Help'
                BYTE    NULL
                STRING       '      - Wyswietla pomoc'
                BYTE    ASC_KOM

cmd_help2:      STRING  '?'
                BYTE    NULL
                STRING    '         - Wyswietla pomoc'
                BYTE    ASC_KOM

cmd_ldzw:       STRING  'Autoansfer'
                BYTE    NULL
                STRING             '- Ustawia liczbe dzwonkow autozgloszenia'
                BYTE    ASC_KOM

cmd_info:       STRING  'INFO'
                BYTE    NULL
                STRING       '      - Informacje o stanie przystawki'
                BYTE    ASC_KOM

cmd_pioo        STRING  'PioOut'
                BYTE    NULL
                STRING         '    - Ustawia port wyjsciowy U20'
                BYTE    ASC_KOM

help_end:       BYTE    ASC_END

;----------------------------------------------------------------------------
;Porwnauje tekst z ROMu z tekstem w buforze "cmd"
;WE: DPTR - adres tekstu w ROM
;    R7   - dugo tekstu do porwnania +1
;WY: C    - status (C=1 - OK, C=0 teksty rne)
;Zmienia: Acc, B, Dptr, R0
;
cmp_cmd:        mov     R0,#cmd_buf             ;Poczatek bufora komendy
cmp_cmd_0:      clr     a                       ;Pobierz znak wzorca
                movc    a,@a+dptr
                lcall   Upper_char
                mov     B,a                     ; zapamietaj go w B
                mov     a,R0                    ;Jeli ostatni porwnany znak
                cjne    a,RR7,cmp_cmd_1
                setb    C                       ; to porwnanie OK - ustaw znacznik OK
                ret
cmp_cmd_1:      mov     a,@R0                   ;Pobierz znak z bufora komendy do porwnania
                cjne    a,B,cmp_cmd_2           ; jeli znaki rne - skok
                inc     R0
                inc     dptr
                sjmp    cmp_cmd_0
cmp_cmd_2:      clr     C                       ; teksty rne - ustaw znacznik FAIL
                ret

;----------------------------------------------------------------------------
set_pioo:       mov     dptr,#msg_pioo          ;Wykonanie komendy
                lcall   print_text
                lcall   wait_byte
                jnc     set_pioo_exit
                lcall   write_pio
                lcall   print_crlf
set_pioo_exit:  ret

msg_pioo:       STRING  'PioOut=$'
                BYTE    NIL

;----------------------------------------------------------------------------
;Czeka na wprowadzenie bajtu w kodach ascii
;WY: Acc - kod znaku
;    C   - status (C=1-OK, C=0-przerwano)
;
wait_byte:      push    B
                lcall   wait_char               ;Czeka na bajt
                jnc     wait_byte_brk
                lcall   ascii_nible             ;Konwersja Ascii -> Hex
                swap    a                       ;Odczytany nible na starsza pozycje
                mov     B,a                     ; wynik zapamitaj w B
                lcall   wait_char               ;Czeka na bajt
                jnc     wait_byte_brk
                lcall   ascii_nible             ;Konwersja Ascii -> Hex
                orl     a,B                     ;poczenie nibli
                pop     B                       ;Znacznik OK
                setb    C
                ret
wait_byte_brk:  clr     C                       ;Znacznik fail
                pop     B
                ret

;----------------------------------------------------------------------------
;Opis: konwertuje ascii na nible (0..9 i A...F) wielko znakw nie ma znaczenia
;we: ACC - kod ASCII
;wy: ACC - w modszym nible cyfra 0...F
;zmienia: PSW, ACC
;
ascii_nible:    cjne    a,#$60,*+3              ;czy wiksze ni $60 ?
                jnc     as_ni_1
                cjne    a,#$40,*+3              ;czy wiksze ni $40 ?
                jnc     as_ni_2
                clr     C
                subb    a,#48                   ;cyfra 0..9
                ret
as_ni_1:        clr     C
                subb    a,#97-10                ;litera A...F
                ret
as_ni_2:        clr     C
                subb    a,#65-10                ;litera a...f
                ret

;----------------------------------------------------------------------------
;Wywietla informacje o przystawce
;
print_info:     lcall   print_about
                mov     dptr,#msg_info0         ;Nagwek
                lcall   print_text
                lcall   print_crlf

                mov     dptr,#msg_info1         ;Info o liczbie dzwonkow
                lcall   print_text
                mov     a,cfg_ldzw
                add     a,#$30
                lcall   print_nible
                lcall   print_crlf

                mov     dptr,#msg_info2         ;Info o nr callback
                lcall   print_text
                lcall   read_callback           ; odczyt nr callback do "cmd_buf"
                mov     R7,#cmd_bufE-cmd_buf
                mov     R0,#cmd_buf
print_info1:    mov     a,@R0
                cjne    a,#NIL,print_info11
                sjmp    print_info12
print_info11:   lcall   print_char
                inc     R0
                djnz    R7,print_info1
print_info12:   lcall   print_crlf

                mov     dptr,#msg_info4         ;Info o ostatnim bdzie
                lcall   print_text
                mov     a,ostatni_err
                lcall   print_hex
                lcall   print_spc
                lcall   print_ost_err           ; info tekstowe o bdzie
                lcall   print_crlf

                mov     dptr,#msg_info5         ;Info o bajtach wysanych/odebranych
                lcall   print_text
                mov     a,bodb2
                lcall   print_hex
                mov     a,bodb1
                lcall   print_nibleH
                lcall   print_przecinek
                lcall   print_nible
                mov     a,bodb0
                lcall   print_hex
                lcall   print_kb

                lcall   print_spc
                mov     dptr,#xram_bodb2
                movx    a,@dptr
                lcall   print_hex
                inc     dptr
                movx    a,@dptr
                lcall   print_nibleH
                lcall   print_przecinek
                lcall   print_nible
                inc     dptr
                movx    a,@dptr
                lcall   print_hex
                lcall   print_kb

                mov     dptr,#msg_info51
                lcall   print_text
                mov     a,bnad2
                lcall   print_hex
                mov     a,bnad1
                lcall   print_nibleH
                lcall   print_przecinek
                lcall   print_nible
                mov     a,bnad0
                lcall   print_hex
                lcall   print_kb

                lcall   print_spc
                mov     dptr,#xram_bnad2
                movx    a,@dptr
                lcall   print_hex
                inc     dptr
                movx    a,@dptr
                lcall   print_nibleH
                lcall   print_przecinek
                lcall   print_nible
                inc     dptr
                movx    a,@dptr
                lcall   print_hex
                lcall   print_kb
                lcall   print_crlf


                mov     dptr,#msg_info7         ;Info o odwiedzinach
                lcall   print_text
                lcall   read_odwiedziny
                mov     a,R7
                lcall   print_hex
                mov     a,B
                lcall   print_hex
                lcall   print_crlf


                mov     dptr,#msg_info3         ;Info o UARcie
                lcall   print_text
                mov     dptr,#ISR
                movx    a,@dptr
                lcall   print_bin
                mov     dptr,#msg_info31
                lcall   print_text
                mov     dptr,#LCR
                movx    a,@dptr
                lcall   print_bin
                mov     dptr,#msg_info32
                lcall   print_text
                mov     dptr,#MCR
                movx    a,@dptr
                lcall   print_bin
                mov     dptr,#msg_info33
                lcall   print_text
                mov     dptr,#MSR
                movx    a,@dptr
                lcall   print_bin
                lcall   print_crlf


                mov     dptr,#msg_info6         ;Info o stosie
                lcall   print_text
                mov	a,#wierzch_stosu   	; wierzch
                lcall   print_hex
                lcall   print_spc
                mov     R0,#dno_stosu           ;Kontroluj stos
info_61:        mov     a,@R0                   ;Odczytaj bajt kontrolny stosu
                cjne    a,#KONT_STOS,info_62    ; jeli rny od wzorca to stos zuzyty
                dec     R0
                mov     a,R0
                cjne    a,#wierzch_stosu,info_61
info_62:        mov     a,R0                    ;Wywietla wynik
                lcall   print_hex
                lcall   print_spc
                mov	a,#dno_stosu      	; dno
                lcall   print_hex
                lcall   print_crlf


                lcall   print_crlf              ;Koniec wydruku
                ret

print_kb:       mov     a,#"k"
                lcall   print_char
                mov     a,#"B"
                lcall   print_char
                ret

msg_info0:      BYTE    CR,LF
                STRING  'Konfiguracja '
                BYTE    NULL

msg_info1:      STRING  'Liczba dzwonkow: '
                BYTE    NULL

msg_info2:      STRING  'Nr Callback: '
                BYTE    NULL

msg_info3:      BYTE    CR,LF
                STRING  'Uart:'
                BYTE    CR,LF
                STRING  'ISR=%'
                BYTE    NULL
msg_info31:     BYTE    CR,LF
                STRING  'LCR=%'
                BYTE    NULL
msg_info32:     BYTE    CR,LF
                STRING  'MCR=%'
                BYTE    NULL
msg_info33:     BYTE    CR,LF
                STRING  'MSR=%'
                BYTE    NULL

msg_info4:      STRING  'Ostatni blad: '
                BYTE    NULL

msg_info5:      STRING  'Liczniki IN:  '
                BYTE    NULL
msg_info51:     BYTE    CR,LF
                STRING  'Liczniki OUT: '
                BYTE    NULL

msg_info6:      STRING  'Stos (wierzch, zuzycie, dno): '
                BYTE    NULL

msg_info7:      STRING  'Polaczen: '
                BYTE    NULL

;----------------------------------------------------------------------------
;Czeka na wprowadzenie liczby dzwonkw
;
prog_ldzw:      mov     dptr,#msg_ldzw
                lcall   print_text
                lcall   wait_char
                jnc     prog_ldzw_brk
                clr     C                               ;Konwertuj z ASCII na HEX
                subb    a,#$30
                anl     a,#$0f                          ; ogranicz liczbe dzwonkw do 16
                mov     cfg_ldzw,a                      ; zapamietaj liczbe dzwonkw
                lcall   read_callback                   ; odtworz nr CollBack
                lcall   write_konfig                    ; Zapisz konfiguracj
                jnc     prog_ldzw_brk
                lcall   print_crlf
                lcall   print_ok
prog_ldzw_brk:  ret


msg_ldzw:       STRING  'Wprowadz liczbe dzwonkow: '
                BYTE    NULL

;----------------------------------------------------------------------------
print_help:     mov     dptr,#msg_help
                lcall   print_text
                mov     dptr,#help_start
prt_hlp0:       clr     a                               ;Pobierz znak
                movc    a,@a+dptr
                cjne    a,#0,prt_hlp1                   ;jeli kod 0
                sjmp    prt_hlp31                       ; to pomi go
prt_hlp1:       cjne    a,#ASC_KOM,prt_hlp2             ;jesli kod ASC_KOM
                lcall   print_crlf                      ; wylij kod CR+LF
                sjmp    prt_hlp3
prt_hlp2:       cjne    a,#ASC_END,prt_hlp3             ;jeli kod ASC_END
                lcall   print_crlf                      ; wyjd z procedury
                ret
prt_hlp3:       lcall   print_char
prt_hlp31:      inc     dptr
                sjmp    prt_hlp0

msg_help:       BYTE    12
                STRING  'Pomoc:'
                BYTE    CR,LF,NULL

;----------------------------------------------------------------------------
nowy_kod_rpt:   mov     dptr,#msg_kod_ver_fail
                lcall   print_text

;Czeka na wprowadzenie nowego kodu 2 x
; jeli kody zgodne to zapisuje je do EEPROM
;
nowy_kod:       lcall   wait_kod                        ;Czeka na kod
                jnc     nowy_kod_fail
                mov     cfg_kod1,cmd_buf                ;Zapamituje kod tymczasowo
                mov     cfg_kod2,cmd_buf+1              ; w RAM
                mov     cfg_kod3,cmd_buf+2
                mov     cfg_kod4,cmd_buf+3
                mov     cfg_kod5,cmd_buf+4
                mov     cfg_kod6,cmd_buf+5
                mov     dptr,#msg_kod_ver               ;Czeka na weryfikacje kodu
                lcall   print_text
                lcall   wait_kod
                jnc     nowy_kod_fail
                mov     a,cmd_buf
                cjne    a,cfg_kod1,nowy_kod_rpt
                mov     a,cmd_buf+1
                cjne    a,cfg_kod2,nowy_kod_rpt
                mov     a,cmd_buf+2
                cjne    a,cfg_kod3,nowy_kod_rpt
                mov     a,cmd_buf+3
                cjne    a,cfg_kod4,nowy_kod_rpt
                mov     a,cmd_buf+4
                cjne    a,cfg_kod5,nowy_kod_rpt
                mov     a,cmd_buf+5
                cjne    a,cfg_kod6,nowy_kod_rpt
                mov     dptr,#msg_kod_ver_ok            ;Weryfikacja poprawna
                lcall   print_text
                lcall   read_callback                   ; odtworz nr CollBack
                lcall   write_konfig                    ; Zapisz konfiguracj
nowy_kod_fail:  lcall   read_konfig                     ;Konieczne aby skopiowac kod
                ret                                     ; jeli by bd podczas wprowadzania

msg_kod_ver:    STRING  'weryfikacja kodu'
                BYTE    CR,LF,NULL

msg_kod_ver_fail:
                STRING  'weryfikacja niepoprawna'
                BYTE    NULL

msg_kod_ver_ok: STRING  'zapamietano nowy kod'
                BYTE    CR,LF,NULL

;----------------------------------------------------------------------------
;Testuje konfigujacje eeprom
; jeli wykryje standardow daje komunikat
;
test_cfg:       mov     a,cfg_kod1
                cjne    a,#STD_KOD1,test_cfg_ok
                mov     a,cfg_kod2
                cjne    a,#STD_KOD2,test_cfg_ok
                mov     a,cfg_kod3
                cjne    a,#STD_KOD3,test_cfg_ok
                mov     a,cfg_kod4
                cjne    a,#STD_KOD4,test_cfg_ok
                mov     a,cfg_kod5
                cjne    a,#STD_KOD5,test_cfg_ok
                mov     a,cfg_kod6
                cjne    a,#STD_KOD6,test_cfg_ok
                mov     dptr,#msg_std_cfg
                lcall   print_text
                setb    FL_STDEEPROM                    ;Ustaw znacznik - standardowy konfig
                ret
test_cfg_ok:    clr     FL_STDEEPROM                    ;Ustaw znacznik - pamie zmieniona
                setb    LED_PROG                        ;wyga ewentualnie zapalowy LED
                ret

msg_std_cfg:    STRING  'Std konfig, zmien kod dostepu !!!'
                BYTE    CR,LF,NULL

;----------------------------------------------------------------------------
print_input:    mov     dptr,#msg_input1
                lcall   print_text
                mov     dptr,#msg_low
                jnb     LED_PROG,*+3
                mov     dptr,#msg_high
                lcall   print_text

                mov     dptr,#msg_input2
                lcall   print_text
                mov     dptr,#msg_low
                jnb     OUT_PROG,*+3
                mov     dptr,#msg_high
                lcall   print_text

                mov     dptr,#msg_input3
                lcall   print_text
                mov     dptr,#msg_low
                jnb     OUT_INIT,*+3
                mov     dptr,#msg_high
                lcall   print_text

                mov     dptr,#msg_input4
                lcall   print_text
                mov     a,#0                    ;Odczyt PioOut (funkcja ustawiania bitw)
                lcall   set_pio
                lcall   print_hex

                mov     dptr,#msg_input5
                lcall   print_text
                lcall   read_pio                ;Odczyt PioIn
                lcall   print_hex

                lcall   print_crlf
                ret

msg_input1:     STRING  'LED='
                BYTE    NULL

msg_input2:     STRING  ' PROG='
                BYTE    NULL

msg_input3:     STRING  ' INIT='
                BYTE    NULL

msg_input4:     STRING  ' PioOut=$'
                BYTE    NULL

msg_input5:     STRING  ' PioIn=$'
                BYTE    NULL

msg_low:        STRING  '0'
                BYTE    NULL

msg_high:       STRING  '1'
                BYTE    NULL

;----------------------------------------------------------------------------
print_oddzwaniam:
                mov     dptr,#msg_oddzwaniam
                lcall   print_text
                ret
msg_oddzwaniam: STRING  'Oddzwaniam...'
                BYTE    CR,LF,NULL

;----------------------------------------------------------------------------
print_syntax:   mov     dptr,#msg_syntax
                lcall   print_text
                ret
msg_syntax:     STRING  'SYNTAX ERROR'
                BYTE    CR,LF,NULL

;----------------------------------------------------------------------------
print_ok:       mov     dptr,#msg_ok
                lcall   print_text
                ret
msg_ok:         STRING  'OK'
                BYTE    NULL

;----------------------------------------------------------------------------
print_connect:  mov     dptr,#msg_connect
                lcall   print_text
                ret
print_about:    mov     dptr,#msg_about1
                lcall   print_text
                mov     dptr,#ISR               ;Odczyt ISR
                movx    a,@dptr
                anl     a,#%11000000            ; jesli bit 6 i 7 ustawiony
                cjne    a,#%11000000,print_about1
                mov     a,#'5'                  ; to jest to uart 16C550
                sjmp    print_about2
print_about1:   mov     a,#'4'                  ; jesli nie to 16C450
print_about2:   lcall   print_char
                mov     dptr,#msg_about2
                lcall   print_text
                mov     dptr,#program_end
                lcall   print_dptr
                lcall   print_crlf
                ret

msg_connect:    BYTE    12
                STRING  'POLACZENIE'
msg_about1:     BYTE    CR,LF
                STRING  'Modem51 ver 1.05 (20.04.2003)'
                BYTE    CR,LF
                STRING  '(C) 2003 by AVT <www.ep.com.pl>'
                BYTE    CR,LF
                STRING  'Autor: Slawomir Skrzynski'
                BYTE    CR,LF
                STRING  '       slawomir.skrzynski@ep.com.pl'
                BYTE    CR,LF
                STRING  'Prog&Emul: Amiga'
                BYTE    CR,LF
                STRING  'UART: 16C'
                BYTE    NULL
msg_about2:     STRING  '50'
                BYTE    CR,LF
                STRING  'RomEnd: $'
                BYTE    NULL

;============================================================================
;Czeka na pojawienie sie tekstu
;WY: patrz "wait_text"
;Zmienia: Acc
;
wait_ok:        push    DPH
                push    DPL
                mov     overtime,#CONST_OK
                mov     dptr,#msg_wait_ok
                lcall   wait_text
                pop     DPL
                pop     DPH
                push    PSW
                mov     a,#CMD_DELAY
                lcall   wait_10ms
                pop     PSW
                ret

;??? doda: jesli przyjdzie komunikat "NO DIALTONE, NO CARRIER, BUSY"
;           to wyj z podprogramu ze znacznikiem bdu
wait_connect:   push    DPH
                push    DPL
                mov     overtime,#CONST_WAIT_CONNECT
                mov     dptr,#msg_wait_connect
                lcall   wait_text
                pop     DPL
                pop     DPH
                push    PSW
                mov     a,#CMD_DELAY
                lcall   wait_10ms
                pop     PSW
                ret

wait_ring:      push    DPH
                push    DPL
                mov     overtime,#CONST_RING
                mov     dptr,#msg_wait_ring
                lcall   wait_text
                pop     DPL
                pop     DPH
                push    PSW
                mov     a,#CMD_DELAY
                lcall   wait_10ms
                pop     PSW
                ret

msg_wait_ok:            STRING  'OK'
                        BYTE    CR,LF,NULL
msg_wait_ring:          STRING  'RING'
                        BYTE    NULL
msg_wait_connect:       STRING  'CONNECT'
                        BYTE    NULL
msg_nocarrier:          STRING  'NO CARRIER'
                        BYTE    NULL
msg_nodialtone:         STRING  'NO DIALTONE'
                        BYTE    NULL
msg_busy:               STRING  'BUSY'
                        BYTE    NULL

;----------------------------------------------------------------------------
;Czeka na pojawienie sie tekstu
;WE: dptr       - adres tekstu zakoczony 0
;    "overtime" - czas po ktry nastapi wyjscie z procedury jeli tekst niepojawi si
;WY: C          - status: C-1 tekst pojawi si
;                         C=0 niepojawi si w odpowiednim czasie
;                             lub nacinito przycisk albo przyszed dzwonek
;    Acc        - przyczyna wyjcia: ST_OK      ???
;                                    ST_OVERTIME
;                                    ST_RING
;                                    ST_SW1
;                                    ST_SW2
;Zmienia: Acc, dptr
;
wait_text:      push    B                       ;rejestry na stos
                push    RR7
                push    RR6
                mov     R7,DPH                  ;Zapamitaj starszy DPTR
                mov     R6,DPL                  ; i modszy
wait_text3:     mov     DPH,R7                  ;Odtwrz starszy DPTR
                mov     DPL,R6
wait_text2:     clr     a                       ;Odczytaj znak do porwnania
                movc    a,@a+dptr
                cjne    a,#0,wait_text1         ;jesli koniec porwnania
                mov     a,#ST_OK                ; ustaw znaczniki OK i wyjd
                setb    C
wait_textE:     pop     RR6                     ;rejetsry ze stosu
                pop     RR7
                pop     B
                ret
wait_text1:     mov     B,a                     ; zapamitaj odczytany znak w B
wait_text5:     lcall   flash_led               ;Migaj ledem
                lcall   get_char                ;Czekaj na znak z modemu
                jc      wait_text4              ; jest to skacz
 ;??? sprawd stan przyciskw i sprztowy dzwonek
                mov     a,overtime              ;Sprawd czy nie min czas
                cjne    a,#0,wait_text5         ; nie min wic dalej czekaj na znak
wait_error:     mov     a,#ST_OVERTIME          ;Min wic wyjd ze znacznikiem
                clr     C                       ; fail
                sjmp    wait_textE
wait_text4:     lcall   Upper_char              ;zamien litery na wielkie
                cjne    a,B,wait_text3          ; jeli znaki rne to porwnuj od nowa
                inc     dptr                    ;znaki takie same wic wskanik na kolejny znak
                sjmp    wait_text2

;----------------------------------------------------------------------------
;Wywoanie procedury powoduje zapalenie leda jesli licznik ma mniej ni 0,5sek.
;                                        lub zapalenie jesli wiecej niz 0,5sek
;
flash_led:      cpl     WDG                             ;Obsuga watchdoga jeli
                jb      FL_FLASH_OFF,flash_led_off      ;Czy zezwolenie na miganie
                push    ACC
                mov     a,licznik100                    ;Migaj ledem
                cjne    a,#50,*+3
                jc      flash_led_on
                clr     LED_YELLOW
                pop     ACC
                jnb     FL_STDEEPROM,*+5                ;Jesli STD CFG to migaj ledem
                clr     LED_PROG
                ret
flash_led_on:
                setb    LED_YELLOW
                pop     ACC
                jnb     FL_STDEEPROM,*+5                ;Jesli STD CFG to migaj ledem
                setb    LED_PROG
flash_led_off:  ret                                     ; wyczone miganie LED`a

;----------------------------------------------------------------------------
break:          mov     dptr,#msg_break
                lcall   print_text
                mov     a,#200                  ;Czekaj 2 sek
                lcall   wait_10ms
hangup:         mov     dptr,#msg_hangup
                lcall   print_text
                mov     a,#250                  ;Czekaj 2,5 sek
                lcall   wait_10ms
                ret

msg_break:      STRING  '+++'                   ;Przerwanie transmisji
                BYTE    NULL

msg_hangup:     STRING  'ATH'
                BYTE    CR,LF,NULL

;----------------------------------------------------------------------------
answer:         mov     dptr,#msg_answer
                lcall   print_text
                ret

msg_answer:     STRING  'ATA'                   ;Zgoszenie
                BYTE    CR,LF,NULL

;----------------------------------------------------------------------------
dial_tone:      mov     dptr,#msg_dial_tone
                lcall   print_text
                ret

msg_dial_tone:  STRING  'ATDT'                  ;Wybieranie tonowe
                BYTE    NULL

;----------------------------------------------------------------------------
;Ustawia linie do transmisji danych, resetuje modem,
;WY: C - status (C=1 - init OK)
;
init_modem:     mov     dptr,#MCR               ;DTR i RTS aktywne
                mov     a,#%1111
                movx    @dptr,a
                mov     dptr,#msg_modem_init    ;acuch inicjalizujcy modem
                lcall   print_text
                lcall   wait_ok
                jnc     init_modem_err
                ret
init_modem_err: mov     a,#ERR_INIT_MODEM
                lcall   print_err
                clr     C
                ret

msg_modem_init: STRING  'ATZ'                   ;acuch inicjalizujcy modem
                BYTE    CR,LF,NULL

                STRING  'ATX3E1V1Q0'
                BYTE    CR,LF,NULL

;============================================================================
;Odczytuje znak ze STDIO
;jeli nie ma znaku zeruje C
;
get_char:       mov     a,stdio                 ; rozdziel zalenie od wyjcia
                cjne    a,#STDIO_MODEM,get_char_1
                ljmp    get_char_mod
get_char_1:     cjne    a,#STDIO_RS2,get_char_2
                ljmp    get_rs
get_char_2:     ret                             ;Nie znaleziono STDIO

;============================================================================
;=       Procedury obsugi TIMERW i zwizanych z nimi przerwaniami         =
;============================================================================
init_timer: 	anl     TMOD,#%11110000         ;Timera 1 nie ruszamy
                orl     TMOD,#%00000001         ;Tryb 1 Timera 0
       		mov	TH0,#SPEED_0h		;zaadowanie timerw
		mov	TL0,#SPEED_0l
                mov     licznik100,#2           ;init dzielnika wstpnego
		setb    TR0			;start timera
		setb    ET0                     ;Zezwolenie na przerwania
                ret

;----------------------------------------------------------------------------
irq_timer:	push    PSW
                push    ACC

		mov	TH0,#SPEED_0h	        ;zaadowanie timerw
		mov	TL0,#SPEED_0l
                lcall   sprawdz_stos            ;Kontrola przepenienia stosu
        ;-------- Dzielnik wstpny przez 100 ------------------
                djnz    licznik100,irq_timer_E  ;Dzielnik wstpny
                mov     licznik100,#100
        ;-------- Ponisze rozkazy wykonywane s co sekund ----
                mov     a,overtime              ;zmiejszenie overtime co 1 sek.
                cjne    a,#0,irq_timer_1        ; jeli rzne od zera
                sjmp    irq_timer_2
irq_timer_1:    dec     overtime
irq_timer_2:

irq_timer_E:    pop     ACC
                pop     PSW
                reti

;----------------------------------------------------------------------------
irq_uart:       push    PSW
                push    ACC
                push    DPH
                push    DPL
                mov     dptr,#ISR
                movx    a,@dptr
            ;???    cjne    a,#%0100,irq_uart_exit  ;Czy przerwanie odbiorcze?

                mov     dptr,#RHR               ; tak wic odczytaj dan z UARTa
                movx    a,@dptr
                mov     dptr,#BUF_RX_MOD        ; oblicz adres w buforze
                mov     DPL,wsk_rx_mod_w
                movx    @dptr,a                 ; zapisz znak do bufora
                inc     wsk_rx_mod_w            ; next adres
                push    ACC                     ;zapamitaj odczytany bajt

 IF RTSCTS=1
                lcall   zuzycie_bufora          ;Sprawd zajeto bufora
                cjne    a,#255-BUF_MARG,*+3     ;czy bufor prawie peny ?
                jc      *+2+3                   ; - nie to skok
                lcall   clr_rts                 ; - tak wic powstrzymaj nadawanie modemu
 ENDI
        ;???    lcall   zuzycie_bufora          ;Sprawd zajeto bufora
        ;       cjne    a,#255,*+3              ;czy bufor zapeniony ?
        ;       jc      *+2+3                   ; - nie to skok
        ;       lcall   ???                     ; - tak wic mamy problem

                pop     ACC                     ;odtwrz zapamitany bajt
irq_uart_exit:  pop     DPL
                pop     DPH
                pop     ACC
                pop     PSW
                reti

;-----------------------------------------------
;Oblicz rznic pomidzy wskanikami "wsk_rx_mod_w" a "wsk_rx_mod_w"
;WE: "wsk_rx_mod_w"
;    "wsk_rx_mod_w"
;WY: Acc - rnica pomiedzy wskanimami
;Zmienia: Acc
;
zuzycie_bufora: clr     C
                mov     a,wsk_rx_mod_w
                subb    a,wsk_rx_mod_r
                jnc     zuzycie_bufora1         ;jeli liczba dodatnia to skoczu
                setb     C                      ; liczba ujemna to oznacza e
                mov     a,wsk_rx_mod_w          ; wskaniki przewiny si
                subb    a,wsk_rx_mod_r          ; i trzeba obliczy odwrotnie
zuzycie_bufora1:ret

;-----------------------------------------------
;Wycz RTS (zatrzymaj nadawanie przez modem)
;WE: --
;WY: --
;Zmienia: Acc, Dptr
;
clr_rts:        mov     dptr,#MCR
                movx    a,@dptr
                clr     ACC+DTR ;RTS
                movx    @dptr,a
                ret

;-----------------------------------------------
;Wcz RTS (zezwl na nadawanie przez modem)
;WE: --
;WY: --
;Zmienia: Acc, Dptr
;
set_rts:        mov     dptr,#MCR
                movx    a,@dptr
                setb    ACC+DTR ;RTS
                movx    @dptr,a
                ret

;----------------------------------------------------------------------------
;Czyta znak z bufora odbiorczego
;WY: Acc - odczytany znak
;    C   - status (C=1 jest znak)
;Zmienia: Acc
;
get_char_mod:   
 IF UARTIRQ=1           ;------- Obsuga UARTa na IRQ ------
                mov     a,wsk_rx_mod_w          ;Czy jest znak w buforze?
                cjne    a,wsk_rx_mod_r,get_char_mod_y
                clr     C                       ;Znacznik - nie ma znaku
                ret
get_char_mod_y: push    DPH                     ; jest - rejestry na stos
                push    DPL
  IF RTSCTS=1
                lcall   zuzycie_bufora          ;Sprawd zajeto bufora
                cjne    a,#BUF_MARG,*+3         ;czy bufor prawie pusty ?
                jnc     *+2+3                   ; - nie to skok
                lcall   set_rts                 ; - tak wic zezwl na nadawanie modemu
  ENDI
                mov     dptr,#BUF_RX_MOD        ; oblicz adres w buforze
                mov     DPL,wsk_rx_mod_r
                movx    a,@dptr                 ; odczytaj znak z bufora
                inc     wsk_rx_mod_r            ; next adres
                lcall   inc_bodb                ;Incrementuj licznik bajtw odebranych
                pop     DPL                     ; wyjd ze znacznikiem - jest znak
                pop     DPH
                setb    C
                ret
 ELSE                   ;------ Obsuga UARTa przez poling -----
                push    DPH
                push    DPL
                mov     dptr,#LSR               ;Sprawdz czy jest cos w rejestrze
                movx    a,@dptr
                anl     a,#1
                cjne    a,#0,get_chat_mod1      ;-jest to skok
                pop     DPL
                pop     DPH
                clr     C                       ;Znacznik nie ma znaku
                ret
get_chat_mod1:  mov     dptr,#RHR               ;Odczytaj znak
                movx    a,@dptr
                pop     DPL
                pop     DPH
                setb    C                       ;Znacznik OK
                ret
 ENDI

;----------------------------------------------------------------------------
;Wpisuje znak do bufora THR i czeka na koniec transmisji
;
put_char_mod:   push    ACC
                push    B
                push    DPH
                push    DPL
 IF RTSCTS=1
                push    ACC                     ;Jeli modem powstrzymuje transmisje to czekaj
                mov     B,#CONST_CTS
                mov     dptr,#MSR
put_char_mod2:  movx    a,@dptr
                jnb     ACC+CTS,put_char_mod3   ; jeli CTS nieaktywne to odliczaj czas
                sjmp    put_char_mod4           ; CTS aktywne wic skocz do nadawania znaku
put_char_mod3:  mov     a,#1                    ;Ptla czasowa
                lcall   wait_10ms
                djnz    B,put_char_mod2         ;jeli niemin czas to skok
                lcall   break                   ; - tak wic rozcz modem
                mov     a,#ERR_CTS
                lcall   print_err
                ljmp    restart                 ;   i restartuj system
put_char_mod4:  pop     ACC
 ENDI
                mov     dptr,#RHR
                movx    @dptr,a
                mov     dptr,#LSR               ;Czeka na koniec transmisji
wait_thr:       movx    a,@dptr
                jnb     Acc.5,wait_thr

                lcall   inc_bnad                ;Incrementuj licznik bajktw nadanych

                pop     DPL
                pop     DPH
                pop     B
                pop     ACC
                ret

;----------------------------------------------------------------------------
init_16C550:    mov     dptr,#LCR               ;Wybierz rejestry podzielnika
                mov     a,#$80
                movx    @dptr,a
                mov     dptr,#DLL               ;Modszy podzielnika
                mov     a,#48                   ; prdko 2400
                movx    @dptr,a
                inc     dptr                    ; starszy podzielnika
                mov     a,#0
                movx    @dptr,a
                mov     dptr,#LCR               ;parametry transmisji
                mov     a,#%11
                movx    @dptr,a
                mov     dptr,#IER               ;wczenie przerwa
 IF UARTIRQ=1           ;------- Obsuga UARTa na IRQ ------
                mov     a,#%0001
 ELSE                   ;------- Obsuga UARTa przez poling ----
                mov     a,#%0000
 ENDI
                movx    @dptr,a
                mov     dptr,#FCR               ;wczenie FIFO
                mov     a,#%1
                movx    @dptr,a
                mov     dptr,#MSR               ;linie nieaktywne
                mov     a,#%1111
                movx    @dptr,a
                mov     wsk_rx_mod_w,#0         ;Wskanik bufora odbiorczego
                mov     wsk_rx_mod_r,#0
                setb    EX0                     ;Zezwlna IRQ od UARTa
                clr     IT0                     ; wyzwalane poziomem
                ret

;----------------------------------------------------------------------------
clr_buf_modem:  lcall   get_char                ;Oczyc bufor odbiorczy
                jc      *-3
                ret


;----------------------------------------------------------------------------
;Obsuga przerwania portu RS
; jeli przyszed znak to wysanie do bufora
;
irq_rs:         push    PSW
		push	ACC
                push    B
                push    RR0
                push    RR1
                push    RR2
                push    RR3
                push    RR4
                push    RR5
                push    RR6
                push    RR7

                jbc     TI,irq_rs_tx            ;Jei przerwanie nadawcze - kasuj o obsu
                mov     a,SBUF                  ;pobierz znak i zapamitaj w Acc
                clr     RI                      ;Potwierd odbir

                lcall   write_fifo              ;Zapisz bajt do FIFO

irq_rs_exit:    pop	RR7                     ;Wyjcie z przerwania
                pop     RR6
                pop     RR5
                pop     RR4
                pop     RR3
                pop     RR2
                pop     RR1
                pop     RR0
                pop     B
                pop     ACC
		pop	PSW
		reti

irq_rs_tx:      setb    FL_TXEMPTY              ;Ustaw znacznik "bufor odbiorczy pusty"
                sjmp    irq_rs_exit             ;Wyjd z IRQ

;--------------------------------------
;Opis: Zapisuje bajt do bufora FIFO. Jeli bufor peny to wychodzi
;      z procedury z ustwionym bitem C w PSW
;we: ACC - bajt do zapsiu
;wy: C   - wynik opwercji: C=1 bufor peny
;                          C=0 OK
;zmienia: ACC, R0, PSW
;
write_fifo:     mov     R0,wsk_fifo_wr          ;Zapisz bajt do FIFO
                mov     @R0,a
                inc     wsk_fifo_wr             ;Wskanik zapisu na next bajt w FIFO
                mov     a,wsk_fifo_wr           ;Jeli przekoroczono bufor FIFO
                cjne    a,#buf_fifo_end,write_fifo_l1
                mov     wsk_fifo_wr,#buf_fifo_str  ; to ustaw na pocztek
write_fifo_l1:  clr     C                       ;komunikuj zapis do fifo OK
                ret

;--------------------------------------
;Opis: Odczytuje bajt z bufora FIFO. Jeli bufor pusty to wychodzi
;      z procedury z zerowanym bitem C w PSW
;we: --
;wy: ACC - odczytany bajt
;    C   - wynik opercji: C=0 bufor pusty
;                         C=1 OK
;zmienia: ACC, R0, PSW
;
read_fifo:      mov     a,status_fifo                   ;Czy wystpiy bdy ?
                cjne    a,#ERROR_OK,fifo_error          ; - tak, wic stacz
                mov     a,wsk_fifo_wr                   ;Czy s bajty w FIFO ?
                cjne    a,wsk_fifo_rd,read_fifo_l1      ; - tak
                clr     C                               ; - nie, wic wyjd z C=0
                ret
read_fifo_l1:   mov     R0,wsk_fifo_rd                  ;Odczytaj bajt z FIFO
                mov     a,@R0
                push    ACC                             ;Zapamitaj bajt na stosie
                inc     wsk_fifo_rd                     ;Wskanik odczytu na next bajt w FIFO
                mov     a,wsk_fifo_rd                   ;Jeli przekoroczono bufor FIFO
                cjne    a,#buf_fifo_end,read_fifo_l2
                mov     wsk_fifo_rd,#buf_fifo_str       ; to ustaw na pocztek
read_fifo_l2:   pop     ACC                             ;Odczytaj bajt ze stosu
                setb    C                               ;Wyjd z C=1
                ret

fifo_error:     lcall   init_fifo                       ;Przepeniono bufor wic wyczy go
                clr     C
                ret

;--------------------------------------
;Opis: Pobranie znaku z bufora RS
;we: --
;wy: ACC - odczytany bajt
;    C   - status C=1 OK
;                 C=0 bufor pusty
;
get_rs:         push    RR0
                lcall   read_fifo                 ;Odczytaj z FIFO
                pop     RR0
                ret

;----------------------------------------------------------------------------
;Opis: Wysya znak na RS
;we: ACC - znak do nadania
;wy: --
;Zmienia: PSW
;
put_rs:         mov	SBUF,a			;Nadaj znak
                clr     FL_TXEMPTY              ;Ustaw znacznik "bufor odbiorczy peny"
                jnb	FL_TXEMPTY,*          	;Czy znak zosta nadany ?
                ret

;----------------------------------------------------------------------------
;Opis: Ustawia prdko transmisji i inicjalizuje sterowik RS
;      prdko transmisji patrz EDW 4/98 str.39
;we: --
;wy: --
;zmienia: PSW
;
init_rs:	mov	SCON,#$50       	;Tryb 3, zezwolenie odbioru
		orl	PCON,#$80		;SMOD=1
                anl     TMOD,#%00001111         ;Timera 0 nie ruszamy
		orl	TMOD,#%00100000		;Tryb 2 Timera 1 (Timer 1 dla RS)

		mov	TH1,#b2400		; - prdko transmisji 2400
		mov	TL1,#b2400
                setb	TR1			;Start timera
                setb    FL_TXEMPTY              ;Ustaw znacznik "bufor odbiorczy pusty"

init_fifo:      mov     status_fifo,#ERROR_OK   ;Status FIFO
                mov     wsk_fifo_wr,#buf_fifo_str
                mov     wsk_fifo_rd,#buf_fifo_str

                setb    ES                      ;Zezwolenie na przerwania z RS
        	ret

;----------------------------------------------------------------------------
test_xram:      mov     dptr,#RAM
                mov     a,#$aa
                movx    @dptr,a
                movx    a,@dptr
                cjne    a,#$aa,test_xram_err
                mov     a,#$55
                movx    @dptr,a
                movx    a,@dptr
                cjne    a,#$55,test_xram_err
                ret

test_xram_err:  mov     a,#ERR_XRAM
                lcall   print_err
                ljmp    restart

;----------------------------------------------------------------------------
test_sio:       mov     dptr,#SIO+7
                mov     a,#$aa
                movx    @dptr,a
                movx    a,@dptr
                cjne    a,#$aa,test_sio_err
                mov     a,#$55
                movx    @dptr,a
                movx    a,@dptr
                cjne    a,#$55,test_sio_err
                ret

test_sio_err:   mov     a,#ERR_SIO
                lcall   print_err
                ljmp    restart

;----------------------------------------------------------------------------
;Opis: Sprawdza komrk kontroln i informuje o przepenienu stosu
;we:
;wy:
;zmienia: PSW, ACC
;
sprawdz_stos:   push    RR0
                mov     R0,#dno_stosu           ;Sprawdza komrk kontroln stosu
                mov     a,@R0
                cjne    a,#KONT_STOS,stos_err_h
                pop     RR0
                ret
stos_err_h:     mov     a,#ERR_STOS
                lcall   print_err
                ljmp    restart

;----------------------------------------------------------------------------
;Wywietla na LED nr bdu porzez liczb migni ledem
; po wywietleniu bdu pauza 2 sekundy i wyjcie z procedury
;WE: Acc - liczba migni
;Zmienia: Acc, B, R6, R7
;
print_err:      mov     ostatni_err,a           ;Zapamietaj bd w RAM

                mov     stdio,#STDIO_LCD        ;Wywietl bd na LCD
                mov     dptr,#msg_err
                lcall   print_text
                mov     a,ostatni_err
                lcall   print_ost_err

                mov     a,ostatni_err           ;Wywietl bd na LED
                mov     B,a
print_err1:     clr     LED_ERROR
                mov     a,#20
                lcall   wait_10ms
                setb    LED_ERROR
                mov     a,#50
                lcall   wait_10ms
                djnz    B,print_err1
                mov     a,#200                  ;Petla 2 sekundy
                lcall   wait_10ms
                ret

msg_err:        BYTE    CLS_ASCII
                STRING  'Err: '
                BYTE    NIL

;----------------------------------------------------------------------------
print_ost_err:  mov     a,ostatni_err
                cjne    a,#ERR_INIT_MODEM,prt_ost_err1
                mov     dptr,#msg_err_init_modem
                sjmp    prt_ost_err0
prt_ost_err1:   cjne    a,#ERR_STOS,prt_ost_err2
                mov     dptr,#msg_err_stos
                sjmp    prt_ost_err0
prt_ost_err2:   cjne    a,#ERR_XRAM,prt_ost_err3
                mov     dptr,#msg_err_xram
                sjmp    prt_ost_err0
prt_ost_err3:   cjne    a,#ERR_SIO,prt_ost_err4
                mov     dptr,#msg_err_sio
                sjmp    prt_ost_err0
prt_ost_err4:   cjne    a,#ERR_EEPROM,prt_ost_err5
                mov     dptr,#msg_err_eeprom
                sjmp    prt_ost_err0
prt_ost_err5:   cjne    a,#ERR_INIT_IIC,prt_ost_err6
                mov     dptr,#msg_err_init_iic
                sjmp    prt_ost_err0
prt_ost_err6:   cjne    a,#ERR_CTS,prt_ost_errE
                mov     dptr,#msg_err_cts
                sjmp    prt_ost_err0
prt_ost_err0:   lcall   print_text
prt_ost_errE:   ret

msg_err_init_modem:     STRING  'Init Modem'
                        BYTE    NULL
msg_err_stos:           STRING  'Stos'
                        BYTE    NULL
msg_err_xram:           STRING  'XRam'
                        BYTE    NULL
msg_err_sio:            STRING  'SIO'
                        BYTE    NULL
msg_err_eeprom:         STRING  'EEProm'
                        BYTE    NULL
msg_err_init_iic:       STRING  'Init IIC'
                        BYTE    NULL
msg_err_cts:            STRING  'CTS'
                        BYTE    NULL

;----------------------------------------------------------------------------
;Czeka czas Acc*1s
;WE: Acc
;Zmienia: Acc
;
wait_1s:        push    ACC
                push    B
wait_1s1:       mov     a,#100                  ; 1 sekunda
                lcall   wait_10ms
                djnz    B,wait_1s1
                pop     B
                pop     ACC
                ret

;----------------------------------------------------------------------------
;Czeka czas Acc*10ms
;WE: Acc
;Zmienia: Acc
;
wait_10ms:      push    B
wait_10ms2:     mov     B,#100                  ; 10ms
wait_10ms1:     lcall   wait_100us
                djnz    B,wait_10ms1
                djnz    Acc,wait_10ms2
                pop     B
                ret

;----------------------------------------------------------------------------
;Czeka 100us
;WE: B
;Zmienia: --
;
wait_100us:     lcall   flash_led               ;Migaj ledem
                push    Acc
                mov	Acc,#FREQUENCY/100*4
                djnz	Acc,*
                pop     Acc
                ret

;============================================================================
;Skanuje magistral IIC, adresy odnalezionych urzdze wysya do modemu
;
scan_iic:       mov     dptr,#msg_scan_iic
                lcall   print_text
                mov     R0,#00h                 ;Najwyszy adres (256)
scan_iic_loop:  mov     a,R0
                lcall   test_adr_iic            ;Czy ukad odpowiada ?
                jnc     scan_iic_loop1
                push    ACC                     ; tak wic wywietl adres na LCD
                mov     a,#"$"
                lcall   print_char
                pop     ACC
                mov     a,R0
                lcall   print_hex
                mov     a,#" "                  ; i zrb odstp
                lcall   print_char
scan_iic_loop1  dec     R0                      ;Next adres
                djnz    R0,scan_iic_loop        ;Czy ostatni ?
                ret                             ; tak wic oznacz, wyjd

test_adr_iic:   lcall	iic_start
		lcall	iic_write
		jc	test_iic_niema		;Sprawdzenie czy ACK
		lcall	iic_stop
                setb    C                       ;C=1 - ukad odpowiedzia
                ret
test_iic_niema: lcall   iic_stop
                clr     C                       ;C=0 - ukad nieodpowiedzia
                ret

msg_scan_iic:   STRING  'Skanuje magistarale IIC... '
                BYTE    CR,LF,NULL

;----------------------------------------------------------------------------
read_konfig:    mov     cnt_crc,#0              ;Zeruj CRC
                mov     dptr,#ee_typ            ;Odczyt identyfikatora pliku konfiguracyjnego
                lcall   read_eeprom
                jnc     read_konfig_err
                cjne    a,#LOW STD_TYP1,std_konfig
                lcall   read_eeprom
                cjne    a,#HIGH STD_TYP1,std_konfig
                lcall   read_eeprom
                cjne    a,#LOW STD_TYP2,std_konfig
                lcall   read_eeprom
                cjne    a,#HIGH STD_TYP2,std_konfig
                mov     dptr,#ee_kod            ;Odczyt kodu dostpu
                lcall   read_eeprom
                mov     cfg_kod1,a
                lcall   read_eeprom
                mov     cfg_kod2,a
                lcall   read_eeprom
                mov     cfg_kod3,a
                lcall   read_eeprom
                mov     cfg_kod4,a
                lcall   read_eeprom
                mov     cfg_kod5,a
                lcall   read_eeprom
                mov     cfg_kod6,a
                lcall   read_eeprom             ;Odczyt liczby dzwonkw
                mov     cfg_ldzw,a
                mov     R7,#cmd_bufE-cmd_buf    ;Odczyt nr callback
                mov     R0,#cmd_buf
read_konfig1:   lcall   read_eeprom
                mov     @R0,a
                inc     R0
                djnz    R7,read_konfig1
                mov     B,cnt_crc               ;Zapamietaj obliczona CRC
                lcall   read_eeprom             ;Odczyt CRC
                cjne    a,B,std_konfig          ;za suma konfigu to "std_konfig"
                ret

read_konfig_err:ret                             ;Bd odczytu EEPROM



;----------------------------------------------------------------------------
read_callback:  mov     dptr,#ee_nr             ;Odczytuje nr callback z eeprom do "cmd_buf"
                mov     R7,#cmd_bufE-cmd_buf    ;Odczyt nr callback
                mov     R0,#cmd_buf
read_callback1: lcall   read_eeprom
                mov     @R0,a
                inc     R0
                djnz    R7,read_callback1
                ret

;----------------------------------------------------------------------------
std_konfig:     mov     cfg_kod1,#STD_KOD1      ;Ustaw standardowy kod
                mov     cfg_kod2,#STD_KOD2
                mov     cfg_kod3,#STD_KOD3
                mov     cfg_kod4,#STD_KOD4
                mov     cfg_kod5,#STD_KOD5
                mov     cfg_kod6,#STD_KOD6
                mov     cfg_ldzw,#STD_LDZW      ;Standardowa liczba dzwonkw
                mov     cmd_buf,#NIL            ;Standardowy nr callback
                sjmp    write_konfig            ; i sprbuj zapisac do EEPROM

;----------------------------------------------------------------------------
write_konfig:
write_konfig0:  mov     cnt_crc,#0              ;Zeruj CRC
                mov     dptr,#ee_typ            ;Zapis identyfikatora pliku konfiguracyjnego
                mov     a,#LOW STD_TYP1
                lcall   write_eeprom
                jnc     write_konfig_error
                mov     a,#HIGH STD_TYP1
                lcall   write_eeprom
                mov     a,#LOW STD_TYP2
                lcall   write_eeprom
                mov     a,#HIGH STD_TYP2
                lcall   write_eeprom
                mov     dptr,#ee_kod            ;Zapis kodu dostpu
                mov     a,cfg_kod1
                lcall   write_eeprom
                mov     a,cfg_kod2
                lcall   write_eeprom
                mov     a,cfg_kod3
                lcall   write_eeprom
                mov     a,cfg_kod4
                lcall   write_eeprom
                mov     a,cfg_kod5
                lcall   write_eeprom
                mov     a,cfg_kod6
                lcall   write_eeprom
                mov     a,cfg_ldzw              ;Zapis liczby dzwonkw
                lcall   write_eeprom
                mov     R7,#cmd_bufE-cmd_buf    ;Zapis nr callback
                mov     R0,#cmd_buf
write_konfig1:  mov     a,@R0
                lcall   write_eeprom
                inc     R0
                djnz    R7,write_konfig1
                mov     a,cnt_crc               ;Zapis CRC
                lcall   write_eeprom
                mov     B,#0                    ;Zeruj licznik odwiedzin
                mov     R7,#0
                lcall   write_odwiedziny
                lcall   print_crlf
                ret
write_konfig_error:                             ;Bd zapisu EEPROM
                ret

msg_wrcfg:      BYTE    CR,LF
                STRING  'Zapisuje konfiguracje...'
                BYTE    NULL

;----------------------------------------------------------------------------
;Zapisuje bajt w EEPROM
;wejcie: DPTR - adres w pamici EEPROM (automatycznie inkrementowany)
;         ACC  - dana do zapisu
;         C    - status (C=1-OK, C=0 bd odczytu)
;zmienia: ACC, R0, DPTR
;
write_eeprom:   lcall   flash_led               ;Migaj ledem
                push    ACC                     ;Dodaj do CRC
                add     a,cnt_crc
                mov     cnt_crc,a
                pop     ACC
                mov     dana_ee,a               ;Zapamietaj dan do zapisu
		lcall	iic_start
		mov	a,#EEPROM_WRITE		;Adres ukadu EEPROM
		lcall	iic_write
		jc	guru_eeprom1		;Sprawdzenie czy ACK
		mov	a,DPL			;Adres bajtu w pamici EEPROM
		lcall	iic_write               ;Modsz bajt ADRESU w EEPROM
		jc	guru_eeprom2		;Sprawdzenie czy ACK
		mov     a,dana_ee       	;Warto bajtu
		inc	dptr			;zwiksz adres
		lcall	iic_write               ;wylij do EEPROM
		lcall	iic_stop
		mov	a,#EEPROM_READ          ;czekanie na koniec operacji zapisu
		lcall	iic_wait
                setb    C                       ;Znacznik OK
		ret

;----------------------------------------------------------------------------
;Odczytuje bajt z EEPROM
;wejcie: DPTR - adres w pamici EEPROM (automatycznie inkrementowany)
;         ACC  - odczytana dana
;wyjcie: Acc  - odczytany bajt
;         C    - status (C=1-OK, C=0 bd odczytu)
;zmienia: ACC, R0, DPTR
;
read_eeprom:	lcall   flash_led               ;Migaj ledem
                lcall	iic_start
		mov	a,#EEPROM_WRITE		;Adres ukadu EEPROM
		lcall	iic_write
		jc	guru_eeprom1		;Sprawdzenie czy ACK
		mov	a,DPL			;Adres bajtu w pamici EEPROM
		lcall	iic_write
		jc	guru_eeprom1		;Sprawdzenie czy ACK
		lcall	iic_start  		;Ponowny warunek startu
		mov	a,#EEPROM_READ
		inc	dptr			;zwiksz adres
		lcall	iic_write
		jc	guru_eeprom1		;Sprawdzenie czy ACK
                lcall	iic_read_np
		lcall	iic_stop
                push    ACC                     ;Dodaj do CRC
                add     a,cnt_crc
                mov     cnt_crc,a
                pop     ACC
                setb    C                       ;Znacznik OK
		ret

;-------------------- komunikaty bdw ---------------------

guru_eeprom1:   mov	dptr,#msg_fail_epr_1    ;ukad nieodpowiada
		lcall	print_text
                clr     C                       ;Znacznik FAIL
		ret

guru_eeprom2:   mov	dptr,#msg_fail_epr_2    ;brak potwierdzenia zapisu
		lcall	print_text
                clr     C                       ;Znacznik FAIL
		ret

                        ;0123456789abcdef
msg_fail_epr_1: BYTE	CR,LF
                STRING	'Brak ACK EEPROM!'
		BYTE	CR,LF,NULL

msg_fail_epr_2: BYTE	CR,LF
                STRING	'Bd zapisu EEPROM!'
		BYTE	CR,LF,NULL

;============================================================================
;Drukuje znak na standardowym wyjciu
;WE: ACC
;Zmienia: --
;
print_char:     lcall   flash_led                       ;Migaj ledem
                push    ACC                     ;Zapamitaj znak do wydrukowania
                mov     a,stdio                 ; rozdziel zalenie od wyjcia
                cjne    a,#STDIO_MODEM,print_char_1
                pop     ACC
                ljmp    put_char_mod
print_char_1:   cjne    a,#STDIO_RS2,print_char_2
                pop     ACC
                ljmp    put_rs
print_char_2:   cjne    a,#STDIO_LCD,print_char_3
                pop     ACC
                ljmp    put_lcd
print_char_3:   pop     ACC                     ;Nie znaleziono STDIO
                ret

;----------------------------------------------------------------------------
print_przecinek:
                push    ACC
                mov     a,#","
                lcall   print_char
                pop     ACC
                ret

;----------------------------------------------------------------------------
clr_bnadodb:    mov     dptr,#xram_bodb2                ;Zeruje bufory
                mov     B,#6
                clr     a
clr_bnadodb1:   movx    @dptr,a
                inc     dptr
                djnz    B,clr_bnadodb1
                ret

res_bnadodb:    mov     dptr,#xram_bodb2                ;Zapamietuje liczbe przeslanych bajtow w XRAM
                mov     a,bodb2
                movx    @dptr,a
                inc     dptr
                mov     a,bodb1
                movx    @dptr,a
                inc     dptr
                mov     a,bodb0
                movx    @dptr,a
                inc     dptr
                mov     a,bnad2
                movx    @dptr,a
                inc     dptr
                mov     a,bnad1
                movx    @dptr,a
                inc     dptr
                mov     a,bnad0
                movx    @dptr,a
res_bnadodb1:   mov     bodb0,#0                        ;Zeruje liczniki przesanych bajtw
                mov     bodb1,#0
                mov     bodb2,#0
                mov     bnad0,#0
                mov     bnad1,#0
                mov     bnad2,#0
                ret

inc_bnad:       push    ACC                             ;Inkrementuje licznik bajtw nadanych
                mov     a,bnad0
                add     a,#1
                da      a
                mov     bnad0,a
                mov     a,bnad1
                addc    a,#0
                da      a
                mov     bnad1,a
                mov     a,bnad2
                addc    a,#0
                da      a
                mov     bnad2,a
                pop     ACC
                ret

inc_bodb:       push    ACC                             ;Incrementuje licznik bajtw odebranych
                mov     a,bodb0
                add     a,#1
                da      a
                mov     bodb0,a
                mov     a,bodb1
                addc    a,#0
                da      a
                mov     bodb1,a
                mov     a,bodb2
                addc    a,#0
                da      a
                mov     bodb2,a
                pop     ACC
                ret


program_end:
;============================================================================
;============================================================================
;============================================================================
;Mapa pamieci EEPROM
                org     $0000
ee_typ:                                                 ;Identyfikator pliku konfiguracji
                org     *+4
ee_kod:                                                 ;Kod dostepu
                org     *+6
ee_ldzw:                                                ;Liczba dzwonkw zgoszenia
                org     *+1
ee_nr:                                                  ;Nr CallBack
                org     *+(cmd_bufE-cmd_buf)+1
ee_crc:                                                 ;Suma kontrolna
                org     *+1
ee_odwiedzinyL:                                         ;Licznik odwiedzin L
                org     *+1
ee_odwiedzinyH:                                         ;Licznik odwiedzin H
                org     *+1

ee_atz:                                                 ;Inicjalizacja modemu ("ATZ" CR)
                org     *+8
ee_atesc:                                               ;Sekwencja ESC ("+++")
                org     *+8
ee_atbreak:                                             ;Break ("ATH" CR)
                org     *+8
ee_atanswer:                                            ;Answer ("ATA" CR)
                org     *+8
ee_atring:                                              ;Ring ("RING")
                org     *+8
ee_atdial:                                              ;Dial ("ATDT")
                org     *+8
ee_atconnect:                                           ;Connect ("CONNECT")
                org     *+8


