unit async;
interface

const
{Znaczniki w statusie
 Status zwraca funkcja ComInputStatus, wywoanie kasuje bdy!}
in_buf_full	=$0001;		{bufor przepeniony}
in_or_err	=$0002;		{Overrun error}
in_pe_err	=$0004;		{Parity error}
in_fe_err	=$0008;		{Framing error}
in_bi_err	=$0010;		{Break interrupt}
in_err_mask	=$001e;		{maska bdw}

xon_xoff_ctrl	=$0100;
cts_rts_ctrl	=$0200; 	{kontrola RTS/CTS}
out_buf_full	=$0400;
MSR_changed	=$0800;		{zmiana CTS,DSR,RI lub DCD}
CTS_asserted	=$1000;		{CTS aktywny}
DSR_asserted	=$2000;		{DSR aktywny}
RI_asserted	=$4000;		{RI qktywny}
DCD_asserted	=$8000;		{DCD aktywny}


type
 _ComPar= record
   PortNr,      {0-COM1/3F8/IRQ4,1-COM2/2F8/IRQ3,3-COM3/3E8/IRQ3,
                 4-COM4/2E8/IRQ4}
   Baud,	{0=1200,1=2400,2=4800,3=9600,4=19200}
   Dial:word;
   FlowCtrl:WORD;	{bit 0=1 ->Xon/Xoff, bit 1=1 -> CTS/RTS}
   DataBits,	{0=5,1=6,2=7,3=8}
   StopBits,	{0=1,1=2}
   Parity,	{0=none,1=odd,2=even}
   Write2Log:word;      {bit 0=1 -> zapis do logu}
   Com_Status:word;
 end;


var
 ComPar:_ComPar;

function ComStatus:word;
procedure ComWrite(C:char);
function ComRead:char;
procedure OpenPort;
procedure ClosePort;
function OutCount:word;	{liczba znakw czekajca na wysanie}
function InCount:word;	{liczba znakw czekajca na odczytanie}

implementation
uses Crt;

var SavExit:pointer;
function ComStatus:word;external;
procedure ComWrite(C:char);external;
function ComRead:char;external;
procedure OpenPort;external;
procedure ClosePort;external;
function OutCount:word;external;
function InCount:word;external;

{$L async.obj}

begin
  FillChar(ComPar,SizeOf(ComPar),0);
  ComPar.DataBits:=3;
  ComPar.Baud:=4;
end.
