{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$M 16384,0,655360}

uses
  Dos, PlFont, Async, Memory, Drivers, Objects, Views, Dialogs, Menus,
  App, TextView, MsgBox, StdDlg;

const
  DialT= 100*18;	{timeout  poczenia 100sek (100 * 18 ticks)}
  cmUstawienia=200;
  cmFormat    =201;
  cmRunExtProg=210;
  cmPolacz=211;
  cmRozlacz=212;
  cmWybierzProgram=213;
  cmDial=205;
  cmWewn=206;
  cmOdbierz=208;

  cmQuitReq =304;
  cmAbout   =305;

  cmModem   =900;
  cmTimeOut        = 998;
  cmModem_Unknown  = 999;
  cmModem_Connect  =1000;
  cmModem_Ok	   =1001;
  cmModem_Busy     =1003;
  cmModem_NoCarrier=1004;
  cmModem_NoDial   =1005;

  StartDir:DirStr='';

type
  Odpowiedz_Modemu =(m_Ok,m_Connect,m_Busy,m_NoCarrier,m_NoDial);

const
  fHex=1;
  fAscii=0;
  Format:word=fAscii;
  Wybieranie:boolean=false;

type
  _DialPar=record
    ComParams:_ComPar;
    Centrala:string[13];
    wewn:string[5];
  end;

  ModemCmd = record
    CmdStr:  string;
    TimeOut: word;
    Event:TEvent;
  end;

  PModemCmd=^ModemCmd;
  TCmdCollection = object(TCollection)
    procedure FreeItem(Item:Pointer);virtual;
  end;

var
  Ticks:word absolute $40:$6c;
  CfgFileName:string[12];
  CurChar,LastChar:char;
  CBuffer:array[0..31] of char;
  BufPtr:word;
  BufLen:integer;
  Buffer:array[0..$7ff] of byte;

  TermText: Text;

  DialPar:_DialPar;

  CmdList:TCmdCollection;	{kolejka komend dla modemu,
  				konieczno buforowania komend wynika
                                z faktu, e przed wysaniem komendy
                                najczciej trzeba poczeka na
                                potwierdzenie poprzedniej (lub upynicie
                                timeout'u)}

  CurrentCmd:ModemCmd;		{aktualna komenda}
  LogFile:Text;

type
  PSettings = ^TSettings;
  TSettings = object(TView)
    procedure Draw;virtual;
  end;

  PModemStatusView=^TModemStatusView;
  TModemStatusView=object(TView)
    procedure Draw;virtual;
  end;

  PTermWin = ^TTermWin;
  TTermWin = object(TWindow)
    Terminal: PTerminal;
    constructor Init(n:integer;VBar:PScrollBar);
    procedure HandleEvent(var Event: TEvent); virtual;
  end;

  TTermApp = object(TApplication)
    Settings:PSettings;
    Program2Run:string;
    ModemStatusView:PModemStatusView;
    constructor Init;
    procedure InitMenuBar;virtual;
    procedure InitStatusLine; virtual;
    procedure HandleEvent(var E:TEvent);virtual;
    function Valid(Command:word):boolean;virtual;
    procedure Idle;virtual;
    procedure Ustawienia;
    procedure UruchomProgram;
    procedure About;
    destructor Done;virtual;
  end;

type

  PDialDialog= ^TDialDialog;
  TDialDialog= object(TDialog)
    BDial:PButton;
    StatusLine:string;
    PCentrala,PWewn:PInputLine;
    constructor Init;
    procedure Draw;virtual;
    procedure HandleEvent(var E:TEvent);virtual;
    procedure GetEvent(var E:TEvent);virtual;
  end;

function Equal(var V1,V2; count:word):boolean;assembler;
asm
	xor	al,al		{Equal:=false}
        mov	cx,count	{liczba bajtw do porwnania}
        push	ds		{zachowaj rejstr DS, obowizkowe w Pascal'u}
        lds	si,V1		{DS:SI adres V1}
        les	di,V2		{ES:DI adres V2}
        cld
        repe	cmpsb   	{dopuki bajty jednakowe porwnuj nastpne}
        jne	@@00		{jeli niejednakowe wyjd z Equal=false}
	inc	al		{Equal:=true}
@@00:   pop	ds		{Odtwrz DS}
end;

procedure UpdateComPar;
begin
  ComPar.PortNr:=DialPar.ComParams.PortNr;
  ComPar.Baud:=DialPar.ComParams.Baud;
  ComPar.DataBits:=DialPar.ComParams.DataBits;
  ComPar.StopBits:=DialPar.ComParams.StopBits;
  ComPar.Parity:=DialPar.ComParams.Parity;
  ComPar.FlowCtrl:=DialPar.ComParams.FlowCtrl;
  ComPar.Dial:=DialPar.ComParams.Dial;
  ComPar.Write2Log:=DialPar.ComParams.Write2Log;
end;

procedure TModemStatusView.Draw;
var B:TDrawBuffer;
    S:string;
    P:array[0..4] of longint;
const
    S1:string[14]='CTS DSR DCD RI';
begin
  MoveChar(B,' ',$78,Size.X);
  MoveStr(B,S1,$78);
  if ComPar.Com_Status and CTS_Asserted<>0 then MoveChar(B,#0,$74,3);
  if ComPar.Com_Status and DSR_Asserted<>0 then MoveChar(B[4],#0,$74,3);
  if ComPar.Com_Status and DCD_Asserted<>0 then MoveChar(B[8],#0,$74,3);
  if ComPar.Com_Status and RI_Asserted<>0 then MoveChar(B[12],#0,$74,2);
  writeline(0,0,Size.X,1,B);
end;

procedure TCmdCollection.FreeItem(Item:Pointer);
begin
  if Item<>nil then Dispose(PModemCmd(Item));
end;

procedure SaveCfg;
var f:file of _DialPar;
begin
  Assign(F,CfgFileName);
  Reset(F);
  if IOresult<>0 then Rewrite(F);
  Write(F,DialPar);
  Close(F);
end;


function Hex(B:byte):string;
const H:array[0..15] of char='0123456789ABCDEF';
begin
  Hex[1]:=H[B shr 4];
  Hex[2]:=H[B and 15];
  Hex[3]:=' ';
  Hex[0]:=#3;
end;


procedure WriteTerm(C:Char);
begin
  case Format of
  fHex:
    begin
      Write(TermText,HEX(byte(C)));
      inc(BufLen,3);
      if ComPar.Write2Log<>0 then Write(LogFile,Hex(byte(C)));
    end;
  fAscii:
    begin
      Write(TermText,C);
      if ComPar.Write2Log<>0 then Write(LogFile,C);
      inc(BufLen,1)
    end;
  end;
  if BufLen>74 then
  begin
    writeln(TermText);
    if ComPar.Write2Log<>0 then WriteLn(LogFile);
    BufLen:=0;
  end;
end;

procedure SendCtrlFile(const CtrlStr:string);
var
    F: Text;
    S, Sout:string;
    I,L :integer;
    Caret: boolean;
    P:PModemCmd;
begin
  Assign(F,CtrlStr);
  reset(F);
  if IOresult<>0 then Exit;
  while not(EOF(F)) do
  begin
    readln(F,S);
    L:=Length(S);
    Sout:='';
    Caret:=false;
    if L=0 then Continue;
    for I:=1 to L do
    begin
      if S[I]='^' then
      begin
        Caret:=true;
        continue;
      end;
      if Caret then
      begin
        Caret:=false;
        if UpCase(S[I])='M' then Sout:=SOut+#13;
      end else Sout:=Sout+S[I];
    end;
    L:=Pos('+++',Sout);
    if L>0 then
    begin
      S:=copy(Sout,1,L+2);
      Sout:=copy(SOut,L+3,255);
    end else S:='';
    if S<>'' then
    begin
      P:=New(PModemCmd);
      P^.CmdStr:=S;
      P^.TimeOut:=2*18;
      P^.Event.What:=0;
      CmdList.Insert(P);
    end;

    P:=New(PModemCmd);
    P^.CmdStr:=Sout;
    P^.TimeOut:=8;
    P^.Event.What:=0;
    CmdList.Insert(P);
  end; {while}
  close(F);
end;

procedure SendCtrl(const CtrlStr:string);
var
  S,Sout:string;
  I,L :integer;
  Caret: boolean;
  P:PModemCmd;
begin
  L:=Length(CtrlStr);
  Sout:='';
  Caret:=false;
  if L=0 then Exit;
  for I:=1 to L do
  begin
    if CtrlStr[I]='^' then
    begin
      Caret:=true;
      continue;
    end;
    if Caret then
    begin
      Caret:=false;
      if UpCase(CtrlStr[I])='M' then Sout:=SOut+#13;
    end else Sout:=Sout+CtrlStr[I];
  end;

  L:=Pos('+++',Sout);

  if L>0 then
  begin
    S:=copy(Sout,1,L+2);
    Sout:=copy(SOut,L+3,255);
  end else S:='';

  if S<>'' then
  begin
    P:=New(PModemCmd);
    P^.CmdStr:=S;
    P^.TimeOut:=2*18;
    P^.Event.What:=0;
    CmdList.Insert(P);
  end;
  P:=New(PModemCmd);
  P^.CmdStr:=Sout;
  P^.TimeOut:=5;
  P^.Event.What:=0;
  CmdList.Insert(P);
end;

procedure DirectSend(const CtrlStr:string);
var
  S,Sout:string;
  I,L :integer;
  Caret: boolean;
begin
  L:=Length(CtrlStr);
  Sout:='';
  Caret:=false;
  if L=0 then Exit;
  for I:=1 to L do
  begin
    if CtrlStr[I]='^' then
    begin
      Caret:=true;
      continue;
    end;
    if Caret then
    begin
      Caret:=false;
      if UpCase(CtrlStr[I])='M' then Sout:=SOut+#13;
    end else Sout:=Sout+CtrlStr[I];
  end;
  if S<>'' then
    for I:=1 to Length(Sout) do  ComWrite(SOut[I]);
end;


constructor TDialDialog.Init;
var
  R:TRect;
  V:PInputLine;
const
  CStr='~C~entrala';
  WStr='~w~ewn.';

begin
  R.Assign(0,0,50,8);
  inherited Init(R,'Poczenie modemowe');
  Options:=Options or ofCentered;
  R.Assign(12,2,12+2+16,3);
  PCentrala:=New(PInputLine,Init(R,13));
  Insert(PCentrala);
  R.Assign(2,2,3+CstrLen(Cstr),3);
  Insert(New(PLabel,Init(R,CStr,PCentrala)));
{  R.Assign(13,3,15,4);
  insert(New(PStaticText,Init(R,'-')));
}
  R.Assign(38,2,38+7,3);
  PWewn:=New(PInputLine,Init(R,5));
  Insert(PWewn);
  R.Assign(31,2,32+CstrLen(Wstr),3);
  Insert(New(PLabel,Init(R,WStr,PWewn)));

  R.Assign(5,4,17,6);
  BDial:=New(PButton,Init(R,'~P~ocz',cmDial,bfNormal));
  Insert(BDial);
  R.Assign(21,4,43,6);
  Insert(New(PButton,Init(R,'~W~ybierz wewntrzny',cmWewn,bfNormal)));
  if DialPar.centrala='' then PCentrala^.Select else BDial^.Select;
end;

procedure TDialDialog.GetEvent(var E:TEvent);
begin
  inherited GetEvent(E);
  if not Wybieranie then
  begin
    if PCentrala^.Data^='' then DisableCommands([cmDial,cmWewn]) else
      EnableCommands([cmDial]);
    if PWewn^.Data^='' then DisableCommands([cmWewn])
      else EnableCommands([cmWewn]);
  end else {Wybieranie}
  begin
    if ComPar.Com_Status and DCD_Asserted<>0 then
    begin
      Wybieranie:=False;
      EndModal(cmModem_Connect);
    end;
  end;
end;

procedure TDialDialog.Draw;
var B:TDrawBuffer;
begin
  inherited Draw;
  MoveChar(B,' ',$4f,Size.X-1);
  MoveStr(B,StatusLine,$4F);
  WriteLine(1,Size.Y-2,Size.X-2,1,B);
end;


procedure TDialDialog.HandleEvent(var E:TEvent);
var s:string;
    P:PModemCmd;
const
  _wybieranie:array[0..1] of char='TP';
  St_Strings:array[Odpowiedz_Modemu] of string[12]=(
    ' OK',
    ' CONNECT',
    ' BUSY',
    ' NO CARRIER',
    ' NO DIALTONE'
    );
begin
  if E.Command=cmCancel then	{cmCancel}
  begin
    if Wybieranie then
      if (MessageBox(^M^C'Przerwa wybieranie?',nil,
        mfConfirmation+mfYesButton+mfNoButton)=cmYes) then
      begin
        CurrentCmd.TimeOut:=0;
        CmdList.FreeAll;
        s:='ATH^M';
        DirectSend(S);
        E.Command:=cmOk;
        Wybieranie:=False;
      end else
      begin
        E.Command:=cmOk;
      end;
  end;{cancel}

  inherited HandleEvent(E);
  if E.What= evBroadcast then
  begin
    case E.Command of
      cmModem:
        begin
          StatusLine:=St_Strings[Odpowiedz_modemu(E.InfoByte)];
          Wybieranie:=False;
          if Odpowiedz_modemu(E.InfoByte)=m_Connect then
             EndModal(cmModem_Connect);
          DrawView;
        end;{cmModem}
    end;{case}
    exit;
  end;{begin}

  if E.What= evCommand then
    case E.Command of
      cmDial:
        begin
          BDial^.Select;
          GetData(DialPar.Centrala);
          if DialPar.Centrala='' then
          begin
            PCentrala^.Select;
            ClearEvent(E);
            Exit;
          end;
          Wybieranie:=True;
          if DialPar.Wewn<>'' then
	  S:='ATD'+ _wybieranie[ComPar.Dial]+ DialPar.Centrala+';'#13#10
          else
	  S:='ATD'+ _wybieranie[ComPar.Dial]+ DialPar.Centrala+#13#10;
          New(P);
          P^.CmdStr:=S;
          P^.TimeOut:=DialT;
          P^.Event.What:=0;
          CmdList.Insert(P);
          StatusLine:=' czenie z numerem '+DialPar.Centrala;
          DisableCommands([cmDial]);
          DrawView;
  	end;
      cmWewn:
        begin
          CurrentCmd.TimeOut:=0;
          CmdList.FreeAll;
  	  Wybieranie:=True;
	  S:='ATDT'+ DialPar.Wewn+#13#10;
          New(P);
          P^.CmdStr:=S;
          P^.TimeOut:=DialT;
          P^.Event.What:=0;
          CmdList.Insert(P);
          StatusLine:=' Wybieranie wewntrznego: '+DialPar.Wewn;
          DrawView;
      	end;
      else Exit;
  end;{case}
    ClearEvent(E);
end;

procedure TTermApp.UruchomProgram;
begin
  ClosePort;
  DoneSysError;
  DoneEvents;
  DoneVideo;
  DoneDosMem;
  SwapVectors;
  Exec(Program2Run, '');
  SwapVectors;
  InitDosMem;
  InitVideo;
  InitEvents;
  InitSysError;
  OpenPort;
  SendCtrlFile(StartDir+'\ENDRUN.CFG');
  Redraw;
end;

procedure TSettings.Draw;
const
  Bauds:array[0..8] of Longint=(600,1200,2400,4800,9600,19200,38400,57600,115200);
  sFormat:array[0..2] of string[5]=('ASCII','HEX','DEC');
var
  P:array[0..4] of longint;
  s:string;
  B:TDrawBuffer;
  C:byte;
begin
  C:=GetColor(4);
  MoveChar(B,' ',C,Size.X);
  P[0]:=longint(@sFormat[Format]);
  P[1]:=succ(ComPar.PortNr);
  P[2]:=Bauds[word(ComPar.Baud)];
  FormatStr(S,'%5s  COM%d B:%d  ',P);
  MoveStr(B,S,C);
  WriteLine(0,0,Size.X,1,B);
end;

constructor TTermWin.Init;
var
  R: TRect;
  HScrollBar, VScrollBar: PScrollBar;
begin
  Desktop^.GetExtent(R);
  inherited Init(R, 'Terminal', wnNoNumber);
  R.Grow(-1, -1);
  Flags:=0;
{  HScrollBar := StandardScrollBar(sbHorizontal or sbHandleKeyboard);
  Insert(HScrollBar);}
  VScrollBar := StandardScrollBar(sbVertical or sbHandleKeyboard);
  New(Terminal, Init(R,nil{ HScrollBar}, VScrollBar, 8192));
  if Application^.ValidView(Terminal) <> nil then
  begin
    AssignDevice(TermText, Terminal);
    Rewrite(TermText);
    Insert(Terminal);
  end;
end;

procedure TTermApp.Ustawienia;
const
  ComX=2;	{szer=11}
  ComY=1;
  ComWidth=15;
  ComItems=4;

  BaudX=ComX+ComWidth+2;
  BaudY=1;
  BaudItems=9;
  BaudWidth=11;

  DialX=BaudX+BaudWidth+2;
  DialY=1;
  DialItems=2;
  DialW=15;

  FlowX=DialX;
  FlowY=DialY+DialItems+2;
  FlowItems=2;
  FlowWidth=15;

  DataX=DialX+DialW+DialItems+1;
  DataY=1;
  DataItems=4;
  DataW=13;

  StopX=DataX;
  StopY=DataY+dataItems+2;
  StopItems=2;
  StopW=13;

  ParityX=StopX;
  ParityY=StopY+StopItems+2;
  ParityItems=3;
  ParityW=13;

var
  D:PDialog;
  R,S:TRect;
  C:PView;
  Sav:_DialPar;
  I:integer;
  Chg:boolean;

begin
  R.Assign(0,0,70,17);
  D:= New(PDialog,Init(R,'Ustawienia'));
  D^.Options:= D^.Options or ofCentered;
  Sav:= DialPar;
  R.Assign(ComX,ComY+1,ComX+ComWidth,ComY+1+ComItems);
  C:= New(PRadioButtons,Init(R,
    NewSItem('1  3F8/4',
    NewSItem('2  2F8/3',
    NewSItem('3  3E8/4',
    NewSItem('4  2E8/3',
    nil))))));
{   PRadioButtons(C)^.EnableMask:=3;}
    D^.Insert(C);
    R.Assign(ComX, ComY, ComX+ComWidth, ComY+1);
    D^.Insert(New(PLabel, Init(R,' ~C~om   Adr/IRQ', C)));

   R.Assign(BaudX, BaudY+1, BaudX+BaudWidth, BaudY+1+BaudItems);
   C:=New(PRadioButtons, Init(R,
     NewSItem('600',
     NewSItem('1200',
     NewSItem('2400',
     NewSItem('4800',
     NewSItem('9600',
     NewSItem('19200',
     NewSItem('38400',
     NewSItem('57600',
     NewSItem('115200',
     nil)))))))))));
   D^.Insert(C);
   R.Assign(BaudX,BaudY,BaudX+BaudWidth,BaudY+1);
   D^.Insert(New(PLabel,Init(R,'~B~aud Rate',C)));

   R.Assign(DialX,DialY+1,DialX+DialW,DialY+3);
   C:=New(PRadioButtons,Init(R,
     NewSItem('Tonowe',
     NewSItem('Impulsowe',
     nil))));
   D^.Insert(C);
   R.Assign(DialX,DialY,DialX+DialW,DialY+1);
   D^.Insert(New(PLabel,Init(R,'~W~ybieranie',C)));

   R.Assign(FlowX,FlowY+1,FlowX+FlowWidth,FlowY+1+FlowItems);
   C:=New(PCheckBoxes,Init(R,
     NewSItem('Xon/Xoff',
     NewSItem('RTS/CTS',
     nil))));
   D^.Insert(C);
   R.Assign(FlowX,FlowY,FlowX+FlowWidth,FlowY+1);
   D^.Insert(New(PLabel,Init(R,'S~t~erowanie',C)));

   R.Assign(DataX,DataY+1,DataX+DataW,DataY+1+DataItems);
   C:=New(PRadioButtons,Init(R,
     NewSItem('5 bitw',
     NewSItem('6 bitw',
     NewSItem('7 bitw',
     NewSItem('8 bitw',
     nil))))));
   D^.Insert(C);
   R.Assign(DataX,DataY,DataX+DataW,DataY+1);
   D^.Insert(New(PLabel,Init(R,'Bity ~D~anych',C)));

   R.Assign(StopX,StopY+1,StopX+StopW,StopY+1+StopItems);
   C:=New(PRadioButtons,Init(R,
     NewSItem('1 bit',
     NewSItem('2 bity',
     nil))));
   D^.Insert(C);
   R.Assign(StopX,StopY,StopX+StopW,StopY+1);
   D^.Insert(New(PLabel,Init(R,'Bity ~S~topu',C)));

   R.Assign(ParityX,ParityY+1,ParityX+ParityW,ParityY+1+ParityItems);
   C:=New(PRadioButtons,Init(R,
     NewSItem('Brak',
     NewSItem('Odd',
     NewSItem('Even',
     nil)))));
   D^.Insert(C);
   R.Assign(ParityX,ParityY,ParityX+ParityW,ParityY+1);
   D^.Insert(New(PLabel,Init(R,'~P~arzysto',C)));

   R.Assign(19,14,19+5,15);
   C:=New(PCheckBoxes,Init(R,
     NewSItem(' ',nil)));
   D^.Insert(C);
   R.Assign(4,14,18,15);
   D^.Insert(New(Plabel,Init(R,'~Z~apis do logu',C)));

   D^.GetExtent(R);
   R.B.Y:=R.B.Y-1;
   R.A.Y:=R.B.Y-2;
   R.A.X:=(R.B.X-R.A.X) div 2 -5;
   R.B.X:=R.A.X+10;
   C:=New(PButton,Init(R,'~O~k',cmOk,bfDefault));
   D^.Insert(C);
   SelectNext(False);
   if ExecuteDialog(D,@DialPar) = cmOK then
   begin
     Chg:=false;
     if Sav.ComParams.PortNr<>DialPar.ComParams.PortNr then Chg:=true;
     if Sav.ComParams.Baud<>DialPar.ComParams.Baud then Chg:=true;
     if Sav.ComParams.DataBits<>DialPar.ComParams.DataBits then Chg:=true;
     if Sav.ComParams.StopBits<>DialPar.ComParams.StopBits then Chg:=true;
     if Sav.ComParams.Parity<>DialPar.ComParams.Parity then Chg:=true;
{    if Sav.ComParams.FlowCtrl<>DialPar.ComParams.FlowCtrl then Chg:=true;}
     if Chg then
     begin
       ClosePort;
       UpdateComPar;
       OpenPort;
       SendCtrlFile(StartDir+'\OPEN.CFG');
     end else UpdateComPar;
   end;
end;

procedure TTermWin.HandleEvent(var Event: TEvent);
begin
  inherited HandleEvent(Event);
end;

procedure TTermApp.HandleEvent(var E:TEvent);
var
  P:PModemCmd;
  S:string;

procedure SetFormat;
var D:PDialog;
    R:TRect;
    C:PView;
begin
  R.Assign(0,0,20,9);
  D:=new(PDialog,Init(R,''));
  with D^ do begin
    Options:=Options or ofCentered;
    R.Assign(3,2,16,5);
    C:=new(PRadioButtons,Init(R,
      NewSItem('ASCII',
      NewSItem('HEX',
      NewSItem('DECIMAL',
      nil)))));
    Insert(C);
    R.Assign(3,1,11,2);
    Insert(New(PLabel,Init(R,'~F~ormat',C)));
    R.Assign(5,6,15,8);
    Insert(New(PButton,Init(R,'  ~O~K   ',cmOK,bfDefault)));
    SelectNext(False);
  end;
  if ExecuteDialog(D,@Format)=cmOK then Settings^.DrawView;
end;

procedure WybierzProgram;

var
  D: PDialog;
  CfgName: string;
  L: Integer;
  P: PModemCmd;
  E: TEvent;
begin
  Program2Run:= '';
  D:= New(PFileDialog, Init('*.exe', 'Uruchom program', '', fdOkButton));
  if ExecuteDialog(D, @Program2Run) <> cmCancel then
  begin
    L:= Length(Program2Run) - 4;	{odetnij '.EXE'}
    CfgName:= Copy(Program2Run, 1, L) + '.CFG';
    SendCtrlFile(CfgName);
    New(P);
    with P^ do
    begin
      CmdStr:= '';
      Event.What:= evCommand;
      Event.Command:= cmRunExtProg;
      CmdList.Insert(P);
    end;
  end;
end;

procedure Edit;
var D: PDialog;
begin
  DisableCommands([cmWybierzProgram, cmRozlacz]);
  D:= New(PDialDialog, Init);
  ExecuteDialog(D, @DialPar.Centrala);
  EnableCommands([cmWybierzProgram, cmRozlacz]);
end;

var
  Q: array[0..3] of Longint;
begin
  inherited HandleEvent(E);
  if E.What = evKeyDown then
    if E.CharCode <> #0 then ComWrite(E.CharCode); {wyslij oprocz kontrolnych}

  if E.What = evCommand then
  begin
    case E.Command of
      cmUstawienia:
        begin
      	  Ustawienia;
          Settings^.DrawView;
        end;
      cmFormat:
	begin
    	  if Format = fHex then Format:= fAscii else Format:= fHex;
    	  Settings^.DrawView;
  	end;
      cmWybierzProgram:	WybierzProgram;
      cmRunExtProg:	UruchomProgram;
      cmPolacz:		Edit;
      cmRozlacz:
        begin
          if MessageBox(^M^C'Rozczy?', nil,
	    mfConfirmation + mfYesButton + mfNoButton) = cmYes then
          SendCtrlFile('CLOSE.CFG');
        end;
      cmQuitReq:
        begin
          CurrentCmd.TimeOut := 0;
	  CmdList.FreeAll;
	  SendCtrlFile('CLOSE.CFG');	{rozlacz}
          New(P);
          with P^ do
          begin
            Event.What := evCommand;
            Event.Command := cmQuit;
            TimeOut := 18;
            CmdStr := '';
          end;
          CmdList.Insert(P);
      	end;
      cmOdbierz:begin
                  S := 'ata' + #13;
                  DirectSend(S);
      		end;
      cmAbout: About;
      else exit;
    end;
    ClearEvent(E);
  end;
end;

procedure TTermApp.Idle;
const
  LastTick: word= 0;
var
  E:Tevent;

function RdPort:boolean;
const
  LF: boolean = false;

  _OK: array[0..1] of char = 'OK';
  _NoCarrier: array[0..9] of char = 'NO CARRIER';
  _Busy: array[0..3] of char = 'BUSY';
  _Connect: array[0..6] of char = 'CONNECT';
  _NoDial1: array[0..10] of char= 'NO DIALTONE';
  _NoDial2: array[0..11] of char= 'NO DIAL TONE';

procedure Analizuj;
var Sa: array[0..15] of char;
    I,J: integer;
    E: TEvent;
    S1: string;

procedure PutAnswer(Cmd:Odpowiedz_Modemu);
var E: TEvent;
begin
  E.What:= evBroadcast;
  E.Command:= cmModem;
  E.InfoByte:= ord(Cmd);
  PutEvent(E);
end;

begin
  I:= BufPtr;
  S1[0]:= #16;
  Move(CBuffer, S1[1], 16);
  for J:=15 downto 0 do
  begin
    I:= pred(I) and 15;
    Sa[J]:= CBuffer[I];
  end;

  if Equal(Sa[15-6], _Connect, 7) then
  begin
    CurrentCmd.TimeOut:= 0;
    PutAnswer(m_Connect);
    Exit;
  end;

  if Equal(Sa[15-1], _OK, 2) then
  begin
    CurrentCmd.TimeOut:= 0;
    PutAnswer(m_OK);
    Exit;
  end;

  if Equal(Sa[15-3], _Busy, 4) then
  begin
    CurrentCmd.TimeOut:= 0;
    PutAnswer(m_Busy);
    Exit;
  end;

  if Equal(Sa[15-9], _NoCarrier, 10) then
  begin
    CurrentCmd.TimeOut:= 0;
    PutAnswer(m_NoCarrier);
    Exit;
  end;

  if Equal(Sa[15-10],_NoDial1, 11) then
  begin
    CurrentCmd.TimeOut:= 0;
    PutAnswer(m_NoDial);
    Exit;
  end;

  if Equal(Sa[15-11], _NoDial2, 12) then
  begin
    CurrentCmd.TimeOut:=0;
    PutAnswer(m_NoDial);
    Exit;
  end;
end;

begin
  RdPort:=false;
  repeat
    if InCount <> 0 then
    begin
    LastChar:= CurChar;
    CurChar:= ComRead;
    end else break;
    case CurChar of
      #10: ;
      #13:
        begin
	  writeln(TermText);
          if ComPar.Write2Log<>0 then writeln(LogFile);
          LF:= False;
          BufLen:= 0;
          RdPort:= true;
  	end;
      else
      begin	{zapisz w buforze ostatnich 16 znakow}
        WriteTerm(CurChar);
	CBuffer[BufPtr]:= CurChar;
        BufPtr:= succ(BufPtr) and 15;
        Analizuj;
      end;
    end;{case}
    break;
  until false;
end;

begin
  inherited Idle;
  ModemStatusView^.DrawView;
  if RdPort then Exit;	{aby zapobiec 2 krotnemu PutEvent}
  if LastTick= Ticks then Exit;
  LastTick:= Ticks;
  if CurrentCmd.TimeOut <> 0 then
  begin
    CurrentCmd.TimeOut:= pred(CurrentCmd.TimeOut);
    if CurrentCmd.TimeOut <> 0 then Exit
     else
    begin
      if CurrentCmd.Event.What = 0 then
      begin
        E.What:= evBroadcast;
        E.Command:= cmTimeout;
        PutEvent(E);
      end else PutEvent(CurrentCmd.Event);
    end;
  end;
  if (OutCount = 0) and (CmdList.Count > 0) then
  begin
    CurrentCmd:= PModemCmd(CmdList.At(0))^;
    CmdList.AtFree(0);
    if CurrentCmd.CmdStr <> '' then DirectSend(CurrentCmd.CmdStr) else
     if (CurrentCmd.Event.What <> 0) and (CurrentCmd.TimeOut = 0) then
       PutEvent(CurrentCmd.Event);
  end;
end;


constructor TTermApp.Init;
var
  TextWin0 : PTermWin;
  R: TRect;
  IOres: Longint;

function GetCfg:Boolean;
var
  F: File of _DialPar;
  P: PathStr;
  D: DirStr;
  N: NameStr;
  E: ExtStr;
begin
  GetDir(0,StartDir);
  P:=ParamStr(0);
  Fsplit(P,D,N,E);
  CfgFilename:=N+'.CFG';
  Assign(F,CfgFileName);
  Reset(F);
  Iores:=Ioresult;
  if IOres<>0 then
  begin
    FillChar(ComPar,SizeOf(DialPar),0);
    DialPar.ComParams.DataBits:= 3;               {8 bitw danych}
    DialPar.ComParams.Baud:= 4;                   {9600}
    GetCfg:= false;
  end else
  begin
    Read(F, DialPar);
    GetCfg:= true;
  end;
  Close(F);
  UpdateComPar;
  Assign(LogFile,N+'.LOG');
  Append(LogFile);
  if IOResult<>0 then Rewrite(LogFile);
end;

begin
  LoadPlFont;
  inherited Init;
  if not GetCfg then
  begin
    About;
    Ustawienia;
  end;
  New(TextWin0, Init(0,nil));
  if ValidView(TextWin0) <> nil then InsertWindow(TextWin0);
  Desktop^.GetExtent(R);
  R.A.X:=R.B.X-43;
  R.B.Y:=R.A.Y+1;
  Settings:=New(PSettings,Init(R));
  Insert(Settings);
  R.A.X:=R.B.X-15;
  ModemStatusView:=new(PModemStatusView,Init(R));
  Insert(ModemStatusView);

  OpenPort;
  CmdList.Init(5,1);
  FillChar(CurrentCmd,SizeOf(CurrentCmd),0);
  SendCtrlFile('OPEN.CFG');
  Desktop^.GetExtent(R);
  R.A.X:=R.B.X-15;
  R.B.Y:=R.A.Y+1;
  ModemStatusView:=new(PModemStatusView,Init(R));
  Insert(ModemStatusView);
end;

procedure TTermApp.About;
var
  R: TRect;
  D: PDialog;
begin
  R.Assign(20, 5, 60, 18);
  D := New(PDialog, Init(R, 'O programie'));
  with D^ do
    begin
      Options := ofCentered;
      Flags := wfClose;
      HelpCtx := hcNoContext;
      R.Assign(10, 2, 32, 3);
      Insert(New(PStaticText, Init(R, 'TERM v1.3 (24.04.2003)')));
      R.Assign(8, 3, 33, 4);
      Insert(New(PStaticText, Init(R, '(c) 2003 AVT-Korporacja')));
      R.Assign(13, 4, 29, 5);
      Insert(New(PStaticText, Init(R, 'www.ep.com.pl')));
      R.Assign(4, 7, 10, 8);
      Insert(New(PStaticText, Init(R, 'Autor:')));
      R.Assign(4, 8, 36, 9);
      Insert(New(PStaticText, Init(R, 'krzysztof.kolaczkowski@ep.com.pl')));
      R.Assign(14, 10, 24, 12);
      Insert(New(PButton, Init(R, '  O~K~  ', cmOK, bfDefault)));
    end;
    Application^.ExecuteDialog(D, nil);
end;

destructor TTermApp.Done;
begin
  CmdList.Done;
  LoadOrgFont;
  Close(LogFile);
  inherited Done;
end;

function TTermApp.Valid(Command:word):boolean;
begin
  if Command=cmQuit then
  begin
    Redraw;
    ClosePort;
    ChDir(StartDir);
    SaveCfg;
    Valid:=true;
  end else inherited Valid(Command);
end;

procedure TTermApp.InitMenuBar;
var
  R:TRect;
begin
  GetExtent(R);
  R.B.Y:=R.A.Y+1;
  MenuBar:=New(PMenuBar,Init(R,NewMenu(
    NewSubMenu('~M~enu',hcNoContext,NewMenu(
      NewItem('Pocz','F1',kbF1,cmPolacz,0,
      NewItem('Uruchom ','F2',kbF2,cmWybierzProgram,0,
      NewItem('Rozcz','F3',kbF3,cmRozlacz,0,
      NewItem('Odbierz','F4',kbF4,cmOdbierz,0,
      NewLine(
      NewItem('~U~stawienia','',kbAltP,cmUstawienia,hcNoContext,
      NewLine(
      NewItem('O programie','',0,cmAbout,hcNoContext,nil
    ))))))))),
    nil))));
end;

procedure TTermApp.InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  StatusLine := New(PStatusLine, Init(R, NewStatusDef(0, $FFFF,
    NewStatusKey('Wyjcie-~AltX~', kbAltX, cmQuitReq,
    NewStatusKey('ASCII/HEX-~AltF~',kbAltF,cmFormat,
{    StdStatusKeys(nil),} nil)),nil)));
end;

var
  TermApp: TTermApp;
begin
  TermApp.Init;
  TermApp.Run;
  TermApp.Done;
end.

