unit	plfont;
interface

procedure LoadPlFont;
procedure LoadOrgFont;

implementation

type
  _BitMap = array[0..31] of byte;
  _SmallMap=array[0..15] of byte;

var
  VgaInternalTab:array[0..255] of _BitMap absolute $B800:00;
  SavChars:array[0..17] of _BitMap;

const
  GraphicsControllerIndexRegister=$3ce;
  SequencerIndexRegister=$3c4;
  GraphicsControllerDataRegister	=$3cf;
  SequencerDataRegister=$3c5;

PlBtm:array[0..17] of _SmallMap=(
  ($00,$00,$00,$00,$00,$78,$0C,$7C,$CC,$CC,$CC,$76,$18,$0E,$00,$00),{a}
  ($00,$00,$0C,$18,$00,$7C,$C6,$C0,$C0,$C0,$C6,$7C,$00,$00,$00,$00),{c}
  ($00,$00,$00,$00,$00,$7C,$C6,$FE,$C0,$C0,$C6,$7C,$18,$0E,$00,$00),{e}
  ($00,$00,$70,$30,$30,$36,$3C,$38,$70,$30,$30,$78,$00,$00,$00,$00),{l}
  ($00,$00,$06,$0C,$00,$DC,$66,$66,$66,$66,$66,$66,$00,$00,$00,$00),{n}
  ($00,$00,$0C,$18,$00,$7C,$C6,$C6,$C6,$C6,$C6,$7C,$00,$00,$00,$00),{o}
  ($00,$00,$0C,$18,$00,$7C,$C6,$60,$38,$0C,$C6,$7C,$00,$00,$00,$00),{s}
  ($00,$00,$18,$18,$00,$FE,$CC,$18,$30,$60,$C6,$FE,$00,$00,$00,$00),{zet}
  ($00,$00,$0C,$18,$00,$FE,$CC,$18,$30,$60,$C6,$FE,$00,$00,$00,$00),{ziet}

  ($00,$00,$10,$38,$6C,$C6,$C6,$FE,$C6,$C6,$C6,$C6,$0C,$06,$00,$00),{A}
  ($0C,$18,$3C,$66,$C2,$C0,$C0,$C0,$C0,$C2,$66,$3C,$00,$00,$00,$00),{C}
  ($00,$00,$FE,$66,$62,$68,$78,$68,$60,$62,$66,$FE,$18,$0E,$00,$00),{E}
  ($00,$00,$F0,$60,$6C,$78,$70,$E0,$60,$62,$66,$FE,$00,$00,$00,$00),{L}
  ($0C,$18,$C6,$E6,$F6,$FE,$DE,$CE,$C6,$C6,$C6,$C6,$00,$00,$00,$00),{N}
  ($0C,$18,$38,$6C,$C6,$C6,$C6,$C6,$C6,$C6,$6C,$38,$00,$00,$00,$00),{O}
  ($0C,$18,$7C,$C6,$C6,$60,$38,$0C,$06,$C6,$C6,$7C,$00,$00,$00,$00),{S}
  ($00,$00,$FE,$C6,$86,$0C,$FE,$30,$60,$C2,$C6,$FE,$00,$00,$00,$00),{Zet}
  ($0C,$18,$FE,$C6,$86,$0C,$18,$30,$60,$C2,$C6,$FE,$00,$00,$00,$00));{Ziet}


procedure SetBitMap(N:Integer;var BitMap);
begin
   { przygotowanie 2 mapy do zapisu map bitowych znakw}

     Port[GraphicsControllerIndexRegister]:=6;
     { rejestr 6 : KONTROLA DOSTPU DO PAMICI}

     Port[GraphicsControllerDataRegister]:=$0c;
{    0c=  0000 1100
                tryb tekstowy
                1 chaining
                00 A000,128kb  10 B000h,32kb
	        01 A000h,64kb   11 B800h,32kb
}
     Port[SequencerIndexRegister]:=4;{ rejestr 4 : KONTROLA OBSLUGI PAMIECI}
     Port[SequencerDataRegister]:=7;
{	7       = 0000 0111b
			 tryb tekstowy
			 ponad 64kb RAM
			 0 tryb ODD/Even}

     Port[SequencerIndexRegister]:=2;{rejestr 2 : ODBLOKOWANIE ZAPISU DO MAP}

     Port[SequencerDataRegister]:=4;
{	  0000 0100b   mapa 2 do zapisu
		 mapa 0
		 mapa 1
		 mapa 2}
     Move(BitMap,VgaInternalTab[N],16);

{przywrcenie standardowego trybu adresowania}

     Port[GraphicsControllerIndexRegister]:=6;
	  {rejestr 6: KONTROLA DOSTPU DO PAMICI}

     Port[GraphicsControllerDataRegister]:=$0e;
     {0000 1110
	    tryb tekstowy
	    1 chaining
	    00 A000h,128kb  10 B000h,32kb
	    01 A000h,64kb   11 B800h,32kb}

     Port[SequencerIndexRegister]:=4;{rejestr 4 : kontrola dostepu do RAM'u}

     Port[SequencerDataRegister]:=3;
{	0000 0011b
	       tryb tekstowy
	       ponad 64KB RAM
	       tryb Odd/Even}

     Port[SequencerIndexRegister]:=2;
     {rejestr 2 : ODBLOKOWYWANIE ZAPISU DO MAP}

     Port[SequencerDataRegister]:=3;
{	0000 0011
	         MAPA 0
	         MAPA 1
}
end;


procedure GetBitMap(CharNr:integer;var BitMap);
begin
{Udostpnienie mapy 2 do odczytu:
 Udostpnieniem map do odczytu steruje rejestr 4 Graphics Controller'a.
 Nalezy podac numer mapy. W trybie tekstowym mapy wystpuj parami,
 wystarczy podac numer jednej z nich;}
   Port[$3ce]:=5;
   Port[$3cf]:=00;	{ wycz odd\even}
   Port[$3ce]:=6;       { zaadresuj rejestr 6 Graphics Controller'a}
   Port[$3cf]:=$c;      {  0000 1100 : B800, 32kb,tryb tekstowy,
				   tryb teksowy
				    wylaczony chaining
				   B800,32kb}
   Port[$3ce]:=4;          { rejestr 4 dostp do odczytu map}
   Port[$3cf]:=2;          { mapa 2 do odczytu}

   Move(VgaInternalTab[CharNr],BitMap,16);
{ Standardowy tryb dostpu do map:}
   Port[$3ce]:=5;
   Port[$3cf]:=$10;
   Port[$3ce]:=6;          { rejestr indeksowy Graphics Controller'a}
			   { rejestr 6 - pooenie pamici
			     ekranu w przestrzeni adresowej CPU}
   Port[$3cf]:=$0e;        { B800h 32kb, chaining}

   Port[$3ce]:=4;          {zaadresuj rejestr 4 Graphics Controller'a}
   Port[$3cf]:=1;          {odblokuj odzczyt do map 0 i 1}
			   { w trybie tekstowym wystepuj parami
			    wystarczy poda numer jednej mapy z pary}
end;

const
  Latin2Chars:array[0..17] of char='䢘'+
  				   '';

procedure LoadPlFont;
var
  I,N:integer;
begin
  for I:=0 to 17 do
  begin
    N:=ord(Latin2Chars[I]);
    GetBitMap(N,SavChars[I]);
    SetBitMap(N,PlBtm[I]);
  end;
end;

procedure LoadOrgFont;
var
  I,N:integer;
begin
  for I:=0 to 17 do
  begin
    N:=ord(Latin2Chars[I]);
    SetBitMap(N,SavChars[I]);
  end;
end;

end.
